proc APSMpSRTurnOnKickersDialog {frame} {
    global status APSMpSRTurnOnKickers
    APSCheckButtonFrame .ikButtons \
      -parent $frame \
      -label "Select SR Kickers" \
      -variableList {APSMpSRTurnOnKickers(IK1) \
		       APSMpSRTurnOnKickers(IK2) \
		       APSMpSRTurnOnKickers(IK3) \
		       APSMpSRTurnOnKickers(IK4) \
		       APSMpSRTurnOnKickers(IK5)} \
      -buttonList "S:IK1 S:IK2 S:IK3 S:IK4 S:IK5" \
      -allNone 1
    APSCheckButtonFrame .isButtons \
      -parent $frame \
      -label "Select SR Septums" \
      -variableList {APSMpSRTurnOnKickers(IS1) \
		       APSMpSRTurnOnKickers(IS2)} \
      -buttonList "S:IS1 S:IS2" \
      -allNone 1
    return 
}


proc APSMpSRTurnOnKickers {args} {
    set IK1 1
    set IK2 1
    set IK3 1
    set IK4 1
    set IK5 0
    set IS1 1
    set IS2 1
    APSStrictParseArguments {IK1 IK2 IK3 IK4 IK5 IS1 IS2}
    APSMpStep init -promptDialog APSMpSRTurnOnKickersDialog \
      -vars "IK1 IK2 IK3 IK4 IK5 IS1 IS2"

    set IKList ""
    set ISList ""
    foreach ik "IK1 IK2 IK3 IK4 IK5" {
	if [set $ik] {
	    append IKList "S:$ik "
	}
    }
    foreach is "IS1 IS2" {
	if [set $is] {
	    append ISList "S:$is "
	}
    }
    if {(![llength $IKList]) && (![llength $ISList])} {
	APSMpReturn ok
    }

    if {[llength $ISList]} {
	APSMpStep "SR: Turn on Septums"
	foreach is $ISList {
	    APSMpStep "SR: Turn on $is septum"
	    set retries 10
	    while {$retries} {
		if {![APScavget -list=${is}:StatusCALC]}  break
		if {[catch {APScavput -list=${is}:ResetSEQ=1} result]} {
		    APSMpReturn error "Error sending on signal to $is septum: $result"
		}
	        APSMpStep "SR: Wait 30 seconds for $is septum to warmup"
		APSWaitWithUpdate -waitSeconds 30
		incr retries -1
	    }
	    if {!$retries} {
                if {[APSPEMTKDialog .warningDialog -text "Unknown problem turning on septum ${is}.\nYou may attempt to turn it on by hand and then click continue."] == 1} {
                    APSMpReturn error "Unknown problem turning on septum."
                }
                set retries 1
	    }
	    APSMpStep "SR: Turn on $is septum succeeded"
	}
    }
    if {[llength $IKList]} {
	APSMpStep "SR: Warmup Kicker"
	if {[catch {APSMpWarmupKickers \
		      -kickerList $IKList} result]} {
            if {[APSPEMTKDialog .warningDialog -text "APSMpSRTurnOnKickers: $result"] == 1} {
                APSMpReturn error "APSMpSRTurnOnKickers: $result"
            }
	}

	APSWaitWithUpdate -waitSeconds 5
	APSMpStep "SR: Turn On Kickers HV"
	if {[catch {APScavput \
		      -list=[join $IKList ,] \
		      -list=:OnBO=ON } result]} {
	    APSMpReturn error "APSMpSRTurnOnKickers: $result"
	}
	APSWaitWithUpdate -waitSeconds 5
	if {[catch {APScavput -list=[join $IKList ,] -list=:ResetBO=1} result]} {
	    APSMpReturn error "APSMpSRTurnOnKickers: $result"
	}
    }
    
    APSMpReturn ok
}

proc APSMpSRTurnOffKickersDialog {frame} {
    global status APSMpSRTurnOffKickers
    APSCheckButtonFrame .ikButtons \
      -parent $frame \
      -label "Select SR Kickers" \
      -variableList {APSMpSRTurnOffKickers(IK1) \
		       APSMpSRTurnOffKickers(IK2) \
		       APSMpSRTurnOffKickers(IK3) \
		       APSMpSRTurnOffKickers(IK4) \
		       APSMpSRTurnOffKickers(IK5)} \
      -buttonList "S:IK1 S:IK2 S:IK3 S:IK4 S:IK5" \
      -allNone 1
    APSCheckButtonFrame .isButtons \
      -parent $frame \
      -label "Select SR Septums" \
      -variableList {APSMpSRTurnOffKickers(IS1) \
		       APSMpSRTurnOffKickers(IS2)} \
      -buttonList "S:IS1 S:IS2" \
      -allNone 1
    return 
}

proc APSMpSRTurnOffKickers {args} {
    set IK1 1
    set IK2 1
    set IK3 1
    set IK4 1
    set IK5 0
    set IS1 1
    set IS2 1
    APSStrictParseArguments {IK1 IK2 IK3 IK4 IK5 IS1 IS2}
    APSMpStep init -promptDialog APSMpSRTurnOffKickersDialog \
      -vars "IK1 IK2 IK3 IK4 IK5 IS1 IS2"

    

    set IKList ""
    set ISList ""
    foreach ik "IK1 IK2 IK3 IK4 IK5" {
	if [set $ik] {
	    append IKList "S:$ik "
	}
    }
    foreach is "IS1 IS2" {
	if [set $is] {
	    append ISList "S:$is "
	}
    }
    if {(![llength $IKList]) && (![llength $ISList])} {
	APSMpReturn ok
    }
    if {[llength $IKList]} {
	APSMpStep "SR: Set Kicker setpoints to 0"
	if [catch {APScavput \
		     -list=[join $IKList ,] \
		     -list=:VoltageSetSendAO=0} result] { 
	    APSMpReturn error "APSMpSRTurnOffKickers: $result"
	}
    }
    if {[llength $ISList]} {
	APSMpStep "SR: Set Septum setpoints to 0"
	if [catch {APScavput \
		     -list=[join $ISList ,] \
		     -list=:VoltageSetSendAO=0} result] { 
	    APSMpReturn error "APSMpSRTurnOffKickers: $result"
	}
    }
    
    
    if {[llength $IKList]} {
	APSMpStep "SR: Wait upto 30 seconds for Kickers readbacks to reach 0"
	set i 0
	while {$i < 30} {
	    incr i
	    APSWaitWithUpdate -waitSeconds 1
	    if {[catch {APScavget \
			  -list=[join $IKList ,] \
			  -list=:DacAI} result]} {
		APSMpStep "SR: Problem reading kicker readbacks: Trying again"
	    } else {
		set pass 1
		foreach ik $IKList rb $result {
		    if {$rb > 1.0} {
			set pass 0
		    }
		}
		if {$pass} { break }
	    }	
	}
    }
    if {[llength $ISList]} {
	APSMpStep "SR: Wait upto 60 seconds for Septums readbacks to reach 0"
	set i 0
	while {$i < 60} {
	    incr i
	    APSWaitWithUpdate -waitSeconds 1
	    if {[catch {APScavget \
			  -list=[join $ISList ,] \
			  -list=:DacAI} result]} {
		APSMpStep "SR: Problem reading septum readbacks: Trying again"
	    } else {
		set pass 1
		foreach is $ISList rb $result {
		    if {$rb > 1.0} {
			set pass 0
		    }
		}
		if {$pass} { break }
	    }	
	}
    }


    if {[llength $IKList]} {
	APSMpStep "SR: Turn Off Kickers HV"
	if [catch {APScavput \
		     -list=[join $IKList ,] \
		     -list=:OnBO=OFF} result] { 
	    APSMpReturn error "APSMpSRTurnOffKickers: $result"
	}
    }
    if {[llength $ISList]} {
	APSMpStep "SR: Turn Off Septums HV"
	if [catch {APScavput \
		     -list=[join $ISList ,] \
		     -list=:OffBO=1} result] { 
	    APSMpReturn error "APSMpSRTurnOffKickers: $result"
	}
    }

    APSMpReturn ok
}
