
# $Log: not supported by cvs2svn $
# Revision 1.198  2012/01/31 20:58:06  shang
# modified APSCompareMachine to use machie request file for obtaining snapshot2 instead of snapshot1 to avoid channel access error because of some pvs in snapshot1 may no longer exist. And added display non-matching pvs in two snapshots.
#
# Revision 1.197  2011/09/28 19:29:44  shang
# modified to return errors of executing sddscasr, so that user would know what the error is when there is errors like "virtual circuit disconnect".
#
# Revision 1.196  2011/04/08 15:41:43  shang
# added label for displaying UBOP link.
#
# Revision 1.195  2011/03/16 15:46:30  shang
# solved the readlink problem for SR UBOP file since it has two layers of link.
#
# Revision 1.194  2011/03/15 19:17:24  shang
# modified install SCR UBOP reference so that it installs the file to the link of SR UBOP, instead of directly to SR UBOP.
#
# Revision 1.193  2010/11/03 21:28:02  shang
# fixed the problem that partial compare does not compare the waveforms no matter they were selected or not.
#
# Revision 1.192  2010/04/26 20:40:52  shang
# now the waveform comparison also uses the tolerance defined in request file.
#
# Revision 1.191  2010/04/14 21:02:03  soliday
# Updated to check the snapshots for blank numerical PV data. If it finds this
# then it will email myself and Hairong as well as notify the operators that
# there probably is an IOC issue that needs to be resolved.
#
# Revision 1.190  2010/03/31 19:53:03  shang
# fixed problem in saving snapshot by sddscasr server that the output file was not correctly obtained from the waveform pv when the pv was being updated.
#
# Revision 1.189  2010/03/31 15:39:48  shang
# made SCR dialog snapshot list expandable.
#
# Revision 1.188  2009/10/13 16:30:07  lemery
# Updated several error messages.
#
# Revision 1.187  2009/09/26 20:24:00  lemery
# Renamed APSSCRAbortCASRControllaw as APSSCRAbortCASRRunControl
#
# Revision 1.186  2009/07/28 16:21:55  shang
# added noConnections argument to APSMakeSCRMatchOptions procedure
#
# Revision 1.185  2009/03/18 20:40:39  shang
# modifed to store the waveform file name as the value of waveform pvs in the snapshot file.
#
# Revision 1.184  2009/03/18 18:35:47  shang
# replaced $waveform by $waveformFile (typo)
#
# Revision 1.183  2009/02/23 21:53:16  shang
# fixed a typo in ramp SR quads procedure
#
# Revision 1.182  2009/02/23 21:08:59  shang
# added SCR dir to SCRFile processing in ramp magnets procedure
#
# Revision 1.181  2009/02/19 20:49:27  shang
# added APSSCRRampSRMagnets and APSSCRTrackRestoreFile procedures.
#
# Revision 1.180  2009/01/23 22:31:02  shang
# added copy waveform file after altering snapshot.
#
# Revision 1.179  2009/01/20 21:53:18  shang
# made SCR able to save, compare and restore waveforms.
#
# Revision 1.178  2008/04/21 18:55:14  soliday
# Fixed a problem with the last change.
#
# Revision 1.177  2008/04/21 18:34:41  soliday
# Added chmod command for waveform output files. The original glob/chmod combo
# command did not work because it was missing an eval so it was combining all
# the file names into one big file name.
#
# Revision 1.176  2008/04/21 17:48:14  soliday
# Removed glob command when processing snapshot. This was slowing it down
# in directories with lots of files.
#
# Revision 1.175  2007/04/02 21:26:19  shang
# added pendIOTime option to APSCompareMachine
#
# Revision 1.174  2006/10/17 22:12:26  shang
# added passing gapDiffTolerance to compare SRXrayBPM (a bug that did not pass it).
#
# Revision 1.173  2006/09/22 17:49:44  shang
# combined the enumerated comparison with numerical comparison.
#
# Revision 1.172  2006/03/29 22:28:49  shang
# added CompareRequestOrMonitorFiles proc to compare the new generated request or monitor file with previous or current in use file.
#
# Revision 1.171  2006/01/26 17:57:13  shang
# changed the pendIOTime for sddscasr to 80s.
#
# Revision 1.170  2005/10/27 20:03:10  soliday
# Updated to work with new features in SaveCompareRestore.
#
# Revision 1.169  2005/10/20 20:53:17  soliday
# Modified procedures to search for routine saves related to shift changes.
#
# Revision 1.168  2005/08/05 15:24:09  borland
# Fixed bug in alter feature due to lack of BackupMsg and RestoreMsg columns in
# sddscasr saves.
#
# Revision 1.167  2005/07/19 15:02:31  soliday
# Replaced setStatusText with $statusCallback
#
# Revision 1.166  2005/07/19 14:52:38  soliday
# The procedure setStatusText was deleted from some unknown file and now
# the procedures in this file would no longer work. I readded the
# setStatusTest procdure and tryed to guess what it did before.
#
# Revision 1.165  2005/07/18 23:35:52  shang
# replace burtrb by sddscasr
#
# Revision 1.164  2005/04/21 15:08:37  soliday
# Modified calculation of FracAbsDifference when comparing two SCR files.
#
# Revision 1.163  2004/11/17 17:59:37  shang
# skips the testing of the existence of IndirectName column for APSSCRAlterSnapshot since
# it does not exist in the snapshot files taken by burtrb.
#
# Revision 1.162  2004/08/10 15:53:46  shang
# added setting outputfile pv to empty string before calling sddscasr saving procedure
#
# Revision 1.161  2004/08/10 14:49:38  shang
# set the outputfile waveform to empty string before doing sddscasr save
#
# Revision 1.160  2004/08/10 14:22:59  shangS
# changed the waiting time for updating files from 10 seconds to 20 seconds in
# APSSaveMachineByCasr proc
#
# Revision 1.159  2004/08/03 14:25:23  shang
# modifed APSCRAlterSnapshot proc to remove the extra colummns from target file
#
# Revision 1.158  2004/05/17 15:53:29  soliday
# Same change
#
# Revision 1.157  2004/05/17 15:51:35  soliday
# Same change as before.
#
# Revision 1.156  2004/05/17 15:49:39  soliday
# The preferred choices are now displayed even when no other files are displayed
# due to the date field.
#
# Revision 1.155  2004/04/21 20:24:25  soliday
# While I don't like code outside of a procedure, especially in a library,
# and that can potentially cause a program to exit, I have only applied a bandaid.
# The code to call APSSCRDefineVariables can be avoided by defining
# apsSkipSCRDefineVariables. Also the method for displaying the error message
# has been changed. It looked to see if tk_version was defined but when apsHelp
# sources this from inside a function it did not check inside the global namespace.
#
# Revision 1.154  2004/04/20 19:25:20  shang
# replaced machine by sys in displaying runcontrol record, since the prefix of
# runcontrol pv sometimes is not the machine name but the sys name.
#
# Revision 1.153  2004/04/20 06:54:22  borland
# Now wait up to 10s for server to make the snapshot.
#
# Revision 1.152  2004/03/23 23:57:11  shang
# added waiting up to 5 seconds if the snapshot file was not updated by the file system
#
# Revision 1.151  2004/03/23 23:33:40  shang
# added APSSaveMachineByCasr, APSSCRCheckCASRControllaw, APSSCRAbortCASRControllaw
# procedures for taking snapshot with sddscasr and modified APSSaveMachine,
# APSCompareMachine for taking snapshot with sddscasr if apsSCRUseCASRServer is not
# zero
#
# Revision 1.150  2004/03/16 16:05:26  shang
# added more arguments to APSCompareMachine for SRXrayBPM system, made APSSaveMachine call
# APSCASRSaveMachine if "use sddscasr server" is selected
#
# Revision 1.149  2004/03/01 22:30:41  shang
# added labelFont argument to APSListMatchSCR proc to set the font for the label
# of SDDS listbox
#
# Revision 1.148  2004/03/01 20:27:53  shang
# added APSCASRSaveMachine,  APSSCRCheckCASRSnapshot, APSSCRProcessSnapshot procedures
# to use sddscasr for saving snapshots; added label and selectMode arguments to
# APSListSCRMatch proc
#
# Revision 1.147  2004/02/10 17:26:01  borland
# Added listOrder option to APSListSCRMatchSetArray and changed spelling
# to to listOrder (from listorder) for APSListSCRMatch.
#
# Revision 1.146  2004/02/03 00:50:27  shang
# added listorder argument to be able to list the files in increasing/descreasing
# order
#
# Revision 1.145  2003/12/15 16:32:23  shang
# added catch to exec statements in APSSaveMachine and changed the display column
# names in APSCompareMachine to have direct meaning of the display columns.
#
# Revision 1.144  2003/10/22 15:39:30  soliday
# Put the call to APSSCRDefineVariables in a catch statement. I also move
# APSFileLineCount out of this file because it is not specifically related to SCR.
#
# Revision 1.143  2003/10/22 13:46:53  borland
# Removed call to APSSCRDefineVariables from APSStandardSetup.
# This call is now executed whenever SCRprocedures.tcl is loaded.
# Modified APSSCRDefineVariables (in SiteSpecificSCR.tcl) so that
# it doesn't do anything except on the first call.
#
# Revision 1.142  2003/10/21 16:04:31  shang
# modified APSSCRPVFilterWidget to list the filters in the listbox for 8 lines instead
# of 4 lines before.
#
# Revision 1.141  2003/10/17 21:39:29  shang
# modified APSSCRPVFilterWidget proc to make the widget expandable (the
# partial compare widget in SaveCompareRestore is expandable now)
#
# Revision 1.140  2003/07/20 18:14:58  borland
# Fixed bug in previous change that resulted in no beamline selections
# begin displayed when apsSCRSuppressSingleBeamline was nonzero and
# there were multiple beamlines.
#
# Revision 1.139  2003/07/18 03:12:42  borland
# Removed debugging statements.
#
# Revision 1.138  2003/07/18 00:41:21  borland
# Removed APS-specific procedures from SCRprocedures.tcl.  They are now
# in SiteSpecificSCR.tcl.  Added a control (apsSCRSuppressSingleBeamline)
# that results in suppression of the beamline suppression widgets when
# there is only one beamline.
# Added SiteSpecificSCR.tcl to the Makefile.Host.
#
# Revision 1.137  2003/06/05 19:46:01  shang
# added sum argument to APSSetMultiplexer proc
#
# Revision 1.136  2003/06/05 16:27:53  shang
# added APSSetTuneMultiplexer proc to set SR:TUNE:Mux4Sw2BO to NASA or VSA
#
# Revision 1.135  2003/03/19 19:11:56  shang
# added setting ${arrayName}(Lattice) for preferred choice
#
# Revision 1.134  2003/03/04 07:16:49  emery
# Fixed several bugs in APSSCRSRCompareBPMQuantities when compare
# in orbitCorrection mode is selected.
#
# Revision 1.133  2003/03/03 17:09:59  shang
# added PreferredOnly option to APSListSCRMatchSetArray proc so that only the
# preferred choices will be listed with this argument is set to 1
#
# Revision 1.132  2002/05/28 07:48:10  borland
# Escaped some square brackets in a text string.
#
# Revision 1.131  2002/05/28 07:39:52  borland
# Modified wildcards in SR convertor comparison procedure to exclude
# PVs that don't have the form S<number>*.
#
# Revision 1.130  2002/02/26 10:46:22  emery
# Removed the addition of the absolute path.
#
# Revision 1.129  2002/02/26 00:48:05  emery
# Added absolute path to variables snapshot1 and snapshot2 in
# proc APSCompareMachine. This was required by changes in previous version.
#
# Revision 1.128  2002/02/22 20:18:06  borland
# Modified so that comparisions can be made without having write permission to
# the snapshot area.  Goes with modified SaveCompareRestore.
#
# Revision 1.127  2002/02/12 20:13:37  soliday
# Added the RFGun Test Stand
#
# Revision 1.126  2002/02/01 21:07:35  emery
# Split two catch statement inside of an "if" for logging a compare action.
#
# Revision 1.125  2002/01/31 18:53:34  emery
# Removed blanks in argument of APSSCRLogAction
#
# Revision 1.124  2002/01/31 18:20:23  emery
# Changed preferred action to install action.
# Adde more information to logAction when installing.
# Added more info on compare logAction.
#
# Revision 1.123  2002/01/28 16:25:35  borland
# APSListSCRMatchSetArray and APSListSCRMatchSetArrayCallback modified to
# allow having several SCR file selection dialogs in one application.
#
# Revision 1.122  2001/10/12 21:03:44  emery
# Restored APSAddToTmpFileList in procedure APSSCRSRCompareBPMQuantities.
#
# Revision 1.121  2001/10/12 20:45:16  emery
# Completed writing of SR custom compare of bpm in orbit correction.
#
# Revision 1.120  2001/10/12 16:42:56  emery
# Added custom compare to SR for comparing bpm setpoints of
# bpms used in orbit correction.
#
# Revision 1.119  2001/09/28 20:04:43  soliday
# I undid the last change.
#
# Revision 1.118  2001/09/28 19:44:24  soliday
# Removed PLET LINAC LEUTL from SCR routine because SCR program was bombing
# now that these directories have been removed.
#
# Revision 1.117  2001/07/06 18:56:48  borland
# The filter file list now has CategoryList and BeamlineList columns that
# are used to set the category and beamline widgets.  Strictly speaking,
# this is not needed but it is reassuring to the user (?).
#
# Revision 1.116  2001/07/06 17:27:49  borland
# Now makes use of wildcard loaded from the predefined filter file.
#
# Revision 1.115  2001/05/03 13:58:24  borland
# Replaced "exec mv" and "file rename" with "file rename -force" in APSCompareMachine
# to avoid errors when doing sorts.
#
# Revision 1.114  2001/04/23 13:19:08  emery
# Remvoed directory from file printout in XrayTranslation custom
# compare.
#
# Revision 1.113  2001/04/23 13:03:33  emery
# Added more descriptive title to XrayTranslation custom compare
# output.
#
# Revision 1.112  2001/04/20 23:11:49  emery
# Improvement to custom script of XrayTranslation: Include values
# from the two snap files in the compare printout.
#
# Revision 1.111  2001/04/20 21:10:03  emery
# Added custom compare scripts to XrayTranslation.
#
# Revision 1.110  2001/03/16 00:10:41  emery
# Added SRVideo system to SR.
#
# Revision 1.109  2001/02/22 20:56:26  borland
# The PLET, LINAC, and LEUTL systems are now under "Obsolete".  The
# LPL and PARNASA systems are now in LINAC/PAR/LEUTL.
#
# Revision 1.108  2001/02/06 19:44:26  soliday
# Fixed some tcl warning messages found with procheck
#
# Revision 1.107  2001/02/01 21:42:17  borland
# Added LPL system to "Special systems"
#
# Revision 1.106  2000/10/27 04:09:43  emery
# Added system XrayTranslation for SR.
#
# Revision 1.105  2000/09/08 13:48:00  borland
# Changed fractional error sort to look at delta/mean rather than delta/tolerance.
#
# Revision 1.104  2000/07/06 21:40:13  emery
# Added -r 10 argument to burtrb for ca connection retries.
#
# Revision 1.103  2000/06/25 23:22:44  borland
# Fixed variable name problem in APSScaleSnapshot.
#
# Revision 1.102  2000/06/14 20:09:07  borland
# Routine save action is logged as "save-routine" rather than "routine-save",
# so it works better with SCRActivityReview.
#
# Revision 1.101  2000/06/14 19:25:20  borland
# Added -routine option to APSSaveMachine so logMessage can log routine vs
# nonroutine save.
#
# Revision 1.100  1999/11/29 14:54:35  borland
# Improved tmp file handling for APSCompareMachine
#
# Revision 1.99  1999/11/17 03:37:31  borland
# Reinstated mysteriously missing APSStrictParseArguments in SR
# converter comparison procedure.
#
# Revision 1.98  1999/11/16 14:04:46  borland
# Now longer put the burtlog file in the tmp file list.  It causes an
# error when the caller tries to display the log.
#
# Revision 1.97  1999/11/15 20:44:37  borland
# Temporary files are now cleaned up more promptly using APSAddToTmpFileList.
#
# Revision 1.96  1999/11/14 04:07:32  borland
# Added use of APSAddToTmpFileList and APSDeleteTmpFileList to APSCompareMachine
# so that temporary files are deleted more promptly.  Need to do more of this
# for other routines (e.g., custom compare routines).  Also, need to
# modify PAR/LET custom plots so they don't require a subprocess (which goofs
# up the deletion).
#
# Revision 1.95  1999/09/27 16:45:40  borland
# Fixed problem with APSAlterSnapshot.  It now ignores the CAError column
# because this doesn't exist in all snapshots.  Also, it reuses lines from
# the replacement file in selecting lines to eliminate from snapshot file.
# This is slower but avoids problems if there are duplicates.
#
# Revision 1.94  1999/08/16 20:19:46  borland
# Added LEUTL system to LINAC group.
#
# Revision 1.93  1999/08/06 15:11:23  borland
# APSListSCRMatchSetArray now sets element ShortFilename in the array to
# "" when initialized.
#
# Revision 1.92  1999/08/02 18:05:07  borland
# Fixed bugs that cropped up when used with linac pems.
#
# Revision 1.91  1999/08/02 17:38:08  borland
# Added APSListSCRMatchSetArray and supporting code.
#
# Revision 1.90  1999/08/02 15:29:13  borland
# Added header to document each procedure.
#
# Revision 1.89  1999/07/29 21:49:50  borland
# Fixed incorrect conditional for error detection in APSSaveMachine.
#
# Revision 1.88  1999/07/28 14:30:04  borland
# Added -numberTest for NewValueString in comparison.
#
# Revision 1.87  1999/07/28 14:01:08  borland
# Disabled use of tclcaGPServer due to bugs that show up when snapshot is
# used (twice) as request fiel.
#
# Revision 1.86  1999/07/27 21:19:56  borland
# Reinstated default use of tclcaget and fixed some related problems.
#
# Revision 1.85  1999/07/27 20:36:41  borland
# Disabled use of GP server as it is not working well.
#
# Revision 1.84  1999/07/27 05:40:57  emery
# Added missing Count column definition for tclc GP server section.
#
# Revision 1.83  1999/07/26 22:47:26  borland
# Added support for using tclcaget and tclcaGPServer for taking snapshots.
#
# Revision 1.81  1999/02/18 19:44:57  borland
# Changed "file delete -f" to "file delete -force".
#
# Revision 1.80  1999/02/17 22:47:34  borland
# Added APSSCRCheckSnapshot procedure.  Used in APSSaveMachine to supplement
# the burtrb log file.  It is apparent that this log file does not always
# contain complete information.
#
# Revision 1.79  1999/02/15 18:39:51  borland
# Added APSScaleSnapshot.
#
# Revision 1.78  1999/01/21 16:31:33  borland
# Now compute Sector number from s for SR bpm comparisons.
#
# Revision 1.77  1999/01/21 15:45:32  borland
# Fixed SR custom compare procedures: For converters, added S4
# sextupoles.  For BPM comparisons, now correctly compares when there
# are more BPMs in one file than the other.
#
# Revision 1.76  1998/11/04 21:50:35  borland
# Added inversion variable for file filtering.
#
# Revision 1.75  1998/10/26 19:26:55  borland
# Made some modifications for SR BPM quantity comparisons and general comparisons
# to deal with files that might have multiple instances of a control name.
#
# Revision 1.74  1998/10/22 12:31:07  borland
# Patched a problem with SR orbit setpoint/offset comparisons due to
# addition of more BPMs.
#
# Revision 1.73  1998/10/16 01:47:37  borland
# Fixed problem in APSSCRAlterSnapshot (description needed to be processed
# by APSMakeSafeQualiferString).
#
# Revision 1.72  1998/08/14 20:35:31  borland
# Added procedures for altering (add, remove, change) SCR request files.
#
# Revision 1.71  1998/08/07 14:50:40  borland
# All procedures now use standard error return method (no -errorinfo).
#
# Revision 1.70  1998/08/07 03:06:12  borland
# Modified use of burtrb in APSSaveMachine.  Under some circumstances, burtrb
# writes errors to stdout, which pollutes the sdds file.  Hence, I can't use
# pipes with burtrb.
#
# Revision 1.69  1998/04/09 19:05:22  borland
# Added -printCommand "enscript -r" to file display windows for main
# compare routine.
#
# Revision 1.68  1998/03/26 15:49:56  borland
# Added "Special systems" group.  Defined new variable to specify order in
# which systems should appear on the pull-down menu.
#
# Revision 1.67  1998/03/26 15:21:21  borland
# Modified behavior of APSSCRDefineVariables; it no longer returns an error
# if there are snapshot directories present that are not accessed.
#
# Revision 1.66  1998/03/24 23:12:34  borland
# Changed preferred/reference file default names from "Preferred" and
# "Reference" to "Operator Preferred" and "System Manager Reference".
#
# Revision 1.65  1998/03/24 22:37:18  borland
# Removed BTS system.
#
# Revision 1.64  1998/03/13 19:44:37  borland
# Fixed some bugs in APSCompareMachine that occured when a custom request file
# was used.
#
# Revision 1.63  1998/02/28 00:22:34  borland
# Fixed alter routine so that it returns the name of the newly created
# snapshot, as expected.
#
# Revision 1.62  1998/02/19 16:13:38  borland
# Added APSSCRMakeSnapshotFilename.  Changed APSSCRAlterSnapshot so that
# it only writes new snapshots to the system directories; it also creates
# a new snapshot now, rather than altering the existing one.  It allows
# giving a description for the altered snapshot.
#
# Revision 1.61  1998/02/16 19:26:49  borland
# Removed temporary rf systems.
#
# Revision 1.60  1998/02/14 23:35:06  borland
# Added code to deal with goofy descriptions that operators sometimes enter.
# E.g., descriptions containing control characters and large numbers of spaces.
#
# Revision 1.59  1998/01/29 16:17:06  borland
# The pv filter string is now reset to "*" when filter flags are reset.
#
# Revision 1.58  1998/01/13 00:44:19  borland
# Fixed labels for bpm quantity comparisons.
#
# Revision 1.57  1998/01/10 20:25:40  borland
# Added SR bpm offset custom comparison.
#
# Revision 1.56  1998/01/07 23:11:48  borland
# When an installation of a preferred file is attempted by someone without
# privileges, the error message now lists the privileged users.
#
# Revision 1.55  1997/11/11 21:24:49  borland
# Improved SR setpoint plots.  Shows P1s and P3/P4s in different colors.
#
# Revision 1.54  1997/10/09 17:15:18  emery
# Added temporary systems for RF systems.
#
# Revision 1.53  1997/09/24 18:20:48  borland
# Fixed minor bug in SR custom compare of orbit setpoints.
#
# Revision 1.52  1997/07/14 18:03:46  borland
# Fixed problem with SR custom converter comparisons that crops up when number
# of converters changes in snapshot file.
#
# Revision 1.51  1997/06/11 14:08:15  borland
# Added new menu-based system selection, also variables for defining
# groups of systems.  Added MPS system.
#
# Revision 1.50  1997/05/23 20:07:30  borland
# Added fractional tolerance sorting to APSCompareMachine.
#
# Revision 1.49  1997/05/07 20:51:13  borland
# Added color coding of converter readback/setpoint difference plots for
# SR.
#
# Revision 1.48  1997/05/02 21:22:34  borland
# Added capability to inhibit writing to the log file.
#
# Revision 1.47  1997/05/02 17:01:14  borland
# Made changes that allow retargeting SCR to a different directory tree.
#
# Revision 1.46  1997/04/24 19:37:38  borland
# Added procedure to allow altering a snapshot.
#
# Revision 1.45  1997/04/23 15:57:45  borland
# Now properly does custom comparisons for snapshot and present state.
#
# Revision 1.44  1997/04/23 15:47:46  borland
# Added code to APSCompareMachine to properly detect null custom comparisons
# list.
#
# Revision 1.43  1997/04/23 15:31:36  borland
# Added support for custom compare facility, plus routines for SR system.
#
# Revision 1.42  1997/03/04 15:49:29  borland
# Comparisons on IsNumerical are now case-insensitive.
#
# Revision 1.41  1997/01/14 15:12:11  borland
# Fixed bug that resulted in failure to show enumerated differences in
# some cases.
#
# Revision 1.40  1996/12/17 14:13:01  borland
# Added BBPMs system.
#
# Revision 1.39  1996/12/15 18:10:36  borland
# Added ID/BM readbacks group.
#
# Revision 1.38  1996/12/14 04:42:25  borland
# Added SRSCDUBits system.
#
# Revision 1.37  1996/12/13 17:01:52  borland
# Added -showSimilarities option to APSCompareMachine.
#
# Revision 1.36  1996/12/03 21:05:08  borland
# Removed some puts statements.  Now use -numberTest option of sddsprocess
# to eliminate nonnumerical ValueStrings that may be returned for
# numerical PVs.
#
# Revision 1.35  1996/11/22 23:26:12  borland
# Now initialize apsSCRFilterFileName when creating the filter file widget.
#
# Revision 1.34  1996/11/15 23:22:37  borland
# Fixed bug in use of casave (still disabled by default).
#
# Revision 1.33  1996/11/14 22:57:55  borland
# Added Preferred file to default list of preferred/reference files.
#
# Revision 1.32  1996/11/14 22:27:44  borland
# Generalized reference file concept to include preferred files; more flexible
# permissions handling.
#
# Revision 1.31  1996/11/14 17:51:30  borland
# Added procedures to support more versatile reference files in SCR.
#
# Revision 1.30  1996/10/17 17:21:39  borland
# Modified "doing save" message to remove pathname.
#
# Revision 1.29  1996/10/17 16:46:28  borland
# Added APSSCRLogAction and use of same by save/compare routines.
#
# Revision 1.28  1996/10/07 23:31:54  borland
# Uses button size controls on various widgets to reduce size of overall widget.
#
# Revision 1.27  1996/10/07 14:58:42  borland
# Added statusCallback option to APSSaveMachine.
#
# Revision 1.26  1996/10/05 00:08:48  borland
# Added more status info for comparison.
#
# Revision 1.25  1996/09/10 20:58:16  borland
# Changed booster manager (for ref file creation) to Sereno and PAR to
# Borland.
#
# Revision 1.24  1996/09/10 00:28:11  borland
# Added PARNASA system.
#
# Revision 1.23  1996/08/23 16:47:00  borland
# Added call to procedure APSSCRDefineVariables to keep old scripts that
# don't call this routine from bombing.
#
# Revision 1.22  1996/08/16 18:18:37  borland
# Added code to change labels for comparisons to indicate which data is the
# reference and which is the present value.
#
# Revision 1.21  1996/08/16 14:23:45  borland
# Fixed error in option string for percent tolerance.
#
# Revision 1.20  1996/08/13 21:45:17  borland
# Added/revised routines for filter-file implementation for compare, review,
# and restore.
#
# Revision 1.19  1996/08/12 19:57:41  borland
# Added height and doneButton options to APSMakeSCRList.
#
# Revision 1.18  1996/08/12 18:26:11  borland
# Added APSSCRMakeLBoxTextLine routine (previously in higher-level applications
# under name MakeLBoxTextLine).
#
# Revision 1.17  1996/08/09 21:50:22  borland
# APSListSCRMatch now takes -callback option to allow specifying routine to
# call when user clicks on choice.
#
# Revision 1.16  1996/08/09 19:56:35  borland
# Added some statements to make sure backup versions of snapshot files are deleted.
#
# Revision 1.15  1996/07/18 19:50:22  borland
# Switched to correct snapshot directory.
#
# Revision 1.14  1996/07/17  14:24:12  borland
# Switched to carestore, but didn't really test.  Checking casave/carestore
# log files for more than two lines (indicating real errors).  Nicer
# pagination of compare printouts, with more information (including
# value1, value2, and description).
#
# Revision 1.13  1996/07/15  20:43:16  borland
# Using new filename conventions (<machine>/YYYY-JJJ-MMDD) and start/end
# date for searches.
#
# Revision 1.12  1996/07/02  15:18:01  borland
# Use regsub to escape square brackets in description fragment prior to
# doing search of configurations.
#
# Revision 1.11  1996/06/18  17:19:03  borland
# Put code into SCRprocedures.tcl to check for blank lines in
# snapshot used as request file.  Otherwise, burtrb barfs.
#
# Revision 1.10  1996/06/11  14:36:08  borland
# Added -manualFieldsOnly switch to APSMakeSCRMatchOptions to allow viewing only
# manual intervention PVs.
#
# Revision 1.9  1996/06/03  21:16:17  borland
# Added code to support using a snapshot as a request file, which is
# needed for doing partial comparisons.
#
# Revision 1.8  1996/05/06  21:37:05  borland
# Added routine-save features.
#
# Revision 1.7  1996/05/06  20:34:29  borland
# Added APSListSCRMatch to simplify save/compare and restore/review scripts.
#
# Revision 1.5  1996/04/03  23:24:18  borland
# Makes use of presorted category and beamline lists when available.
# Does fewer operations when a temporary saveset is made.
#
# Revision 1.4  1996/03/30  01:55:06  borland
# Modified category and beamline sorts to break up files for better
# performance.
#
# Revision 1.3  1996/03/17  01:32:43  borland
# Eliminated some blank lines that cppatch complained about.
#
# Revision 1.2  1996/03/17  01:31:42  borland
# Added sorting and tolerance overrides.
#
# Revision 1.1  1996/03/17  00:28:19  borland
# First version.
#
#

# List of procedures:
# APSSCRLogAction : uses logMessage utility to log SCR actions for latter review
# APSSCRSystemChoiceWidget : creates a menu for selecting an SCR system
# APSSCRMakeSystemSubMenu : used by APSSCRSystemChoiceWidget to make submenus
# APSSCRSetSystemList : defines which systems will be used in SCR operations
#   Used to restrict the list of systems.
# APSMakeSCRMatchOptions : returns a list of options for use with sddsprocess to
#   accomplish a specific matching/filtering operation on a snapshot or request file.
# APSCheckSCRSelections : checks for selection of one or more beamline and one or more
#   category items
# APSClearSCRFilterFlags : clears/resets all filter/category/beamline selections.
# APSSCRMakeSnapshotFilename : returns a name to be used for a permanent snapshot file
# APSSaveMachine : makes a permanent or temporary snapshot for a specified machine
# APSSCRCheckSnapshot : Checks a snapshot for bad data, returning the number of bad rows.
#   Puts a line in the logFile with this info, also.
# APSCompareMachine : compares two snapshots, or one snapshot and the present state.
# APSListSCRMatch : creates a listbox for use in selecting snapshots for a specific
#  machine, between specific dates, and matching a specific description pattern.
# APSListSCRMatchSetArray : improved version of APSListSCRMatch that sets values into
#  a user-supplied array.  Presents two lists, one for normal snapshots and one for
#  preferred/reference snapshots.
# APSListSCRMatchSetArrayCallback : callback routine used by APSListSCRMatchSetArray
#  to set the array values and call the users callback routine.
# APSSCRMakePrefLBoxTextLine : used by APSListSCRMatchSetArray to make the listbox text
#  for preferred/reference snapshots.  The regular snapshot list must be made first.
# APSSCRMakeLBoxTextLine : makes listbox text lines for APSListSCRMatch
# APSFileLineCount : counts the number of lines in a file.
# APSSCRFilterFileCallback : used by filter-file selection listbox for handling user's
#  filter file choices.
# APSSCRPVFilterWidget : creates widgets for specifying filtering of PVs.  This includes
#  category and beamline selection, a wildcard string, and (in some cases) filter file
#  selections.
# APSSCRDateTimeEntryWidget : make widget for date/time entry for start and end of
#   region on interest
# APSSCRResolvePreferredFileChoice : accepts a preferred file choice and system name and
#   returns the snapshot name
# APSSCRGetPreferredChoiceList : returns the list of preferred files available for a system,
#   for display to the user.
# APSSCRGetPreferredDataLists : returns the list of preferred files, suffixes, and allowed
#   users for a system.
# APSSCRInstallPreferredFile : installs a snapshot as a specific preferred file.
# APSSCRAlterSnapshot : alters a snapshot by replacing data with data from a second
#  file.  The second file has the same columns as a snapshot. 
# APSAlterSCRRequestFile : changes a request file using data from other files to
#  indicate what to remove, add, rename, or replace.
# APSAddToSCRRequestFile : adds data to a request file.
# APSRemoveFromSCRRequestFile : removes data from a request file.
# APSRenameInSCRRequestFile : renames data in a request file.  I.e., it changes the
#  ControlNames.
# APSMakeSCRCategoryFiles : takes a request file and makes another SDDS file
#  containing one row for each unique value of a specified column.
#  Used for making category and beamline lists after creating a
#  new request file.
# APSScaleSnapshot : scales the numerical values in a snapshot by a specified
#  factor.

set SCRdebug 0

# This procedure must be called.  The procedure is in SiteSpecificSCR.tcl
# and is responsible for checking for SCR directories and setting up
# global variables for other SCR procedures.

if {(![info exists apsSkipSCRDefineVariables]) || ($apsSkipSCRDefineVariables == 0)} {
    if {[catch {APSSCRDefineVariables} apsSCRDefineVariablesResults]} {
        global tk_version
        if {[info exists tk_version]} {
            update
            APSAlertBox .errorMessage -errorMessage "Error (APSSCRDefineVariables): $apsSCRDefineVariablesResults"
            exit
        } else {
            puts stderr "Error (APSSCRDefineVariables): $apsSCRDefineVariablesResults"
            exit
        }
    }
}

proc APSSCRLogAction {args} {
    set file ?
    set action ?
    set script ?
    global apsScriptCommand apsSCRInhibitActionLogging
    if $apsSCRInhibitActionLogging return
    if [info exists apsScriptCommand] {
        set script $apsScriptCommand
    }
    if [APSStrictParseArguments {file action script}]==-1 {
        return -code error "APSSCRLogAction: invalid arguments"
    }
    if [catch {exec whoami} user] {
        set user ?
    }
    if [catch {exec uname -snr} host] {
        set host ?
    }
    if [catch {exec logMessage -sourceId=SCRAudit \
                 -tag=User $user \
                 -tag=Host $host \
                 -tag=File $file \
                 -tag=Action $action \
                 -tag=Script $script} result] {
        return -code error $result
    }
}

proc APSSCRGetUBOPLink {args} {
    global apsSCRSystem apsSCRUbopLink
    if {$apsSCRSystem=="SR"} {
	set oldDir [pwd]
	cd /home/helios/oagData/SCR/snapshots/SR
	set link [file tail [file readlink SR-UserBeamPreferred.gz]]
	switch $link {
	    SR-UserBeamPreferredNoP0Feedback.gz {
		set apsSCRUbopLink "without P0 feedback"
	    }
	    SR-UserBeamPreferredWithP0Feedback.gz {
		set apsSCRUbopLink "with P0 feedback"
	    }
	    default {
		return -code error "Invalid SR UBOP link -- $link"
	    }
	}
    } else {
	set apsSCRUbopLink ""
    }
}

proc APSSCRSystemChoiceWidget {widget args} {
    global apsSCRSystemList apsSCRSystem apsSCRUbopLink
    set parent .
    set menuParent .menu
    set variable apsSCRSystem
    set command ""
    set mode menu
    APSStrictParseArguments {parent variable command menuParent mode}

    if [string compare $mode buttons]==0 {
        set w0 $parent$widget
        APSFrameGrid $widget -parent $parent -xList {x1 x2} \
          -contextHelp "Selects SCR system"

        global $variable
        set index 0
        foreach system [lsort $apsSCRSystemList] {
            if [expr $index%16]==0 {
                set w $w0.x1.f$index
                frame $w
                pack $w -side top
            }
            incr index
            APSButton .b$system -parent $w -text $system -size small\
              -command "set $variable $system ; $command" \
              -contextHelp "Changes system choice to $system"
        }
        APSLabeledOutput .current -parent $w0.x2 -label "Current choice: " \
          -textVariable $variable -width 14
    } else {
        APSLabeledOutput $widget -parent $parent -label "Current system choice: " \
          -textVariable $variable -width 14 \
          -contextHelp "A system is the basic unit SCR deals with. Save files are made and accessed for individual systems only.  While you may save several systems in sequence using a group save, these systems are saved in an independent fashion in separate files."
#	APSSCRGetUBOPLink
	#APSLabeledOutput ${widget}1 -parent $parent -label "UBOP link to" \
	 \#   -textVariable apsSCRUbopLink -width 40 \
	   \# -contextHelp "display the SR UBOP link, blank for other system"
#	APSButton .get -parent $parent${widget}1 -size small -text "Get" -packOption "-side right" -command "APSSCRGetUBOPLink"
        APSMenubarAddMenu .syschoice -text "System" -parent $menuParent
        set w $menuParent.syschoice.menu
        global apsSCRGroupDescription apsSCRGroupMembers apsSCRGroupMenuOrder
        set index 0
        foreach item $apsSCRGroupMenuOrder {
            incr index
            APSSCRMakeSystemSubMenu .group$index -parent $w -label $apsSCRGroupDescription($item) \
              -variable $variable -command $command -groupName $item \
              -systemList $apsSCRGroupMembers($item)
        }
    }
}

proc APSSCRMakeSystemSubMenu {widget args} {
    set parent "" 
    set label "NoLabel"
    set systemList ""
    set variable ""
    set command ""
    set groupName ""
    APSStrictParseArguments {parent label systemList variable command groupName}

    menu $parent$widget
    $parent add cascade -label $label -menu $parent$widget
    set w $parent$widget
    if ![winfo exists $w] {
        puts stderr "Not found: $w"
        return
    }
    foreach item $systemList {
        $w add command -label $item -command \
          "set $variable $item; set apsSCRGroup $groupName; $command"
    }
}

proc APSSCRSetSystemList {systemList} {
    global apsSCRSystemList apsSCRSystemFlag apsSCRSystem
    if [llength $systemList] {
        set apsSCRSystemList $systemList
        set apsSCRSystem [lindex $systemList 0]
    } else {
        APSSCRDefineVariables
    }
    foreach element $apsSCRSystemList {
        set apsSCRSystemFlag($element) 0
    }
    set apsSCRSystemFlag($apsSCRSystem) 1
    set apsSCRSystem $apsSCRSystem
}

proc APSMakeSCRMatchOptions {file args} {
    global apsSCRFilterBeamline apsSCRFilterCategory 
    global apsSCRSuppressSingleBeamline
    set includeReadOnlys 0
    set protectionLock 1
    set pvNameFilter "*"
    set manualFieldsOnly 0
    set invertChoices 0
    set noConnections 0
    APSStrictParseArguments {includeReadOnlys protectionLock pvNameFilter manualFieldsOnly \
                               invertChoices noConnections}
    set snapshotColumnList [APSGetSDDSNames -class column -fileName $file]
    if [llength $snapshotColumnList]<2 {
        return -code error "APSMakeSCRMatchOptions: Too few columns in snapshot file"
    }
    set matchOpt1 ""
    set first 1
    set count(1) [llength [array names apsSCRFilterBeamline]]
    if {$apsSCRSuppressSingleBeamline && $count(1)==1} {
        set matchOpt1 -match=column,Beamline=*
    } else {
        foreach filt [array names apsSCRFilterBeamline] {
            if {$apsSCRFilterBeamline($filt)} {
                if {$first} {
                    set matchOpt1 "-match=column,Beamline=$filt"
                    set first 0
                } else {
                    set matchOpt1 "${matchOpt1},Beamline=$filt,\\|"
                }
            }
        }
    }
    set matchOpt2 ""
    set first 1
    set count(2) [llength [array names apsSCRFilterCategory]]
    foreach filt [array names apsSCRFilterCategory] {
        if {$apsSCRFilterCategory($filt)} {
            if {$first} {
                set matchOpt2 "-match=column,Category=$filt"
                set first 0
            } else {
                set matchOpt2 "${matchOpt2},Category=$filt,\\|"
            }
        }
    }
    set matchOpt3 ""
    if {$pvNameFilter != "*"} {
        set count(3) 2
        set first 1
        foreach pvNameFilter0 [split $pvNameFilter ,] {
            regsub -all {\[} "$pvNameFilter0" {\[} name1
            regsub -all {\]} "$name1" {\]} name2
            if $first {
                set matchOpt3  "-match=column,ControlName=${name2}"
            } else {
                append matchOpt3 ,ControlName=$name2,|
            }
            set first 0
        }
    } else {
        set count(3) 1
    }

    set matchOpt4 ""
    if {$protectionLock && [lsearch -exact $snapshotColumnList IsProtected]!=-1} {
        set matchOpt4 "-match=column,IsProtected=+n"
    }

    set matchOpt5 ""
    if {!$includeReadOnlys && [lsearch -exact $snapshotColumnList IsReadOnly]!=-1} {
        set matchOpt5 "-match=column,IsReadOnly=+n"
    }

    set matchOpt6 ""
    if {$manualFieldsOnly && [lsearch -exact $snapshotColumnList OpsIntervention]!=-1} {
        set matchOpt6 "-match=column,OpsIntervention=+y"
    }

    if $invertChoices {
        # don't invert protection, read-only, or manual only
        foreach opt {1 2 3} {
            if {$count($opt)>1 && [string length [set matchOpt$opt]]} {
                append matchOpt$opt ,!
            }
        }
    }
    set matchOpt7 ""
    if $noConnections {
        set matchOpt7 "-match=col,ValueString=_NoConnection_"
    }
    return -code ok "$matchOpt1 $matchOpt2 $matchOpt3 $matchOpt4 $matchOpt5 $matchOpt6 $matchOpt7"
}

proc APSCheckSCRSelections {} {
    global apsSCRFilterBeamline apsSCRFilterCategory apsSCRSuppressSingleBeamline
    set beamline 0
    if {$apsSCRSuppressSingleBeamline && [llength [array names apsSCRFilterBeamline]]==1} {
        set beamline 1
    } else {
        if {[info exists apsSCRFilterBeamline]} {
            foreach filt [array names apsSCRFilterBeamline] {
                if [subst \$apsSCRFilterBeamline($filt)] {
                    set beamline 1
                    break
                }
            }       
        }
    }
    if !$beamline {
        return 0
    }
    if {[info exists apsSCRFilterCategory]} {
        foreach filt [array names apsSCRFilterCategory] {
            if [subst \$apsSCRFilterCategory($filt)] {
                return 1
            }
        }
    }
    return 0
}

proc APSClearSCRFilterFlags {} {
    global apsSCRFilterBeamline apsSCRFilterCategory apsSCRFilterFileName apsSCRPVNameFilter
    global apsSCRInvertFilterFile apsSCRFilterFileDescription apsSCRPVSetpointFilter
    if {[info exists apsSCRFilterBeamline]} {
        foreach filt [array names apsSCRFilterBeamline] {
            set apsSCRFilterBeamline($filt) 0
        }       
    }
    if {[info exists apsSCRFilterCategory]} {
        foreach filt [array names apsSCRFilterCategory] {
            set apsSCRFilterCategory($filt) 0
        }
    }
    set apsSCRPVNameFilter "*"
    set apsSCRPVSetpointFilter 0
    set apsSCRFilterFileName ""
    set apsSCRFilterFileDescription ""
    set apsSCRInvertFilterFile 0
}

proc APSSCRMakeSnapshotFilename {args} {
    global apsSCRRequestDir apsSCRSnapDir apsSCRSystem
    set machine ""
    if [APSStrictParseArguments {machine}] {
        return -code error "APSSCRMakeSnapshotFilename: bad argument"
    }

    if [string length $machine]==0 {
        set machine $apsSCRSystem
    }

    if ![file exists [file join $apsSCRRequestDir $machine.req]] {
        return -code error "Bad machine name $machine" 
    }

    set oldDir [pwd]
    cd [file join $apsSCRSnapDir $machine]

    catch {exec timeconvert -now} timeList 
    set dt \
      [format %4ld-%03ld-%02ld%02ld-%02ld%02ld%02ld \
         [lindex $timeList 0] [lindex $timeList 1] \
         [lindex $timeList 2] [lindex $timeList 3] \
         [lindex $timeList 5] [lindex $timeList 6] \
         [lindex $timeList 7] ]
    while 1 {
        set snapshot ${machine}${dt}
        if {[file exists $snapshot] || [file exists $snapshot.gz]} {
            catch {exec timeconvert -now} timeList 
            set dt \
              [format %4ld-%03ld-%02ld%02ld-%02ld%02ld%02ld \
                 [lindex $timeList 0] [lindex $timeList 1] \
                 [lindex $timeList 2] [lindex $timeList 3] \
                 [lindex $timeList 5] [lindex $timeList 6] \
                 [lindex $timeList 7] ]
        } else {
            cd $oldDir
            return [concat $snapshot $timeList]
        }
    }
}

proc APSSaveMachine {args} {
    global apsSCRRequestDir apsSCRSnapDir SCRdebug 
    global apsSCRUseCarestore apsSCRUseGPServer apsSCRUseCASRServer
    set machine ""
    set description ""
    set snapshot ""
    set temporary 0
    set requestFile ""
    set statusCallback "APSNoOp"
    set routine 0
    set pendIOTime 80
    set pingTimeOut 80
    if [APSStrictParseArguments {machine description snapshot temporary requestFile \
                                   statusCallback routine pendIOTime pingTimeOut }] {
        return -code error "APSSaveMachine: bad arguments"
    }
    if $apsSCRUseCASRServer {
        if [catch {APSSaveMachineByCasr -machine $machine -description $description \
                     -pendIOTime $pendIOTime -pingTimeOut $pingTimeOut \
                     -snapshot $snapshot -temporary $temporary -requestFile $requestFile \
                     -statusCallback $statusCallback -routine $routine} result] {
            return -code error "APSSaveMachine: $result"
        }
        return $result
    }
    if ![file exists [file join $apsSCRRequestDir $machine.req]] {
        return -code error "APSSaveMachine: Bad machine name $machine" 
    }

    set oldDir [pwd]
    cd [file join $apsSCRSnapDir $machine]

    if $SCRdebug {
        puts stderr "Directory changed to [pwd]"
    }

    if {[string length $snapshot]==0} {
        set snapshot [APSSCRMakeSnapshotFilename -machine $machine]
        set timeList [lrange $snapshot 1 end]
        set snapshot [lindex $snapshot 0]
    } else {
        catch {exec timeconvert -now} timeList 
    }
    
    if [string length $description] {
        set description [APSMakeSafeQualifierString $description]
    }

    if [string length $requestFile]==0 {
        set requestFile ${apsSCRRequestDir}/${machine}.req 
    }
    if ![file exists $requestFile] {
        cd $oldDir
        return -code error "APSSaveMachine: $requestFile not found" 
    }
    if $SCRdebug {
        puts stderr "Using request file $requestFile"
    }

    set logFile /tmp/[APSTmpString].burtlog
    set tmpID [APSUniqueName tmpID]
    if $temporary {
        set tmpReqFile /tmp/[APSTmpString]
        APSAddToTmpFileList -ID $tmpID -fileList $tmpReqFile
        if [string compare [file extension $requestFile] ".gz"]==0 {
            if [catch {exec gzip -dcn $requestFile \
                         | sddsprocess -pipe=in -match=col,ControlName=,! \
                         -match=col,ControlType=,! $tmpReqFile } result] {
                cd $oldDir
                return -code error "APSSaveMachine1: $result"
            }
            set requestFile $tmpReqFile
            if $SCRdebug {puts stderr "Using request file $tmpReqFile" }
        } else {
            if [catch {exec sddsprocess $requestFile -match=col,ControlName=,! \
                         -match=col,ControlType=,! $tmpReqFile } result] {
                cd $oldDir
                return -code error "APSSaveMachine2: $result"
            }
        }
        if $apsSCRUseGPServer {
            if $SCRdebug {
                puts stderr "Using GPServer to take snapshot."
                puts stderr "request file: $tmpReqFile [exec sddscheck $tmpReqFile]"
            }
            catch {exec tclcaGPServer &}
            after 1000
            if [catch {exec tclcaget -requestFile $tmpReqFile -pipe out \
                         -logFile $logFile.sdds \
                         | sddsprocess -pipe=in $snapshot \
                         "-redefine=column,Count,1,type=long" \
                         "-reprint=column,Lineage,-" \
                         "-reprint=column,BackupMsg,-" \
                         "-reprint=column,RestoreMsg,-" \
                         "-reprint=column,ControlType,pv" \
                         "-reprint=column,ControlMode,-" } result] {
                if $SCRdebug { puts stderr "Error from GPServer: $result" }
            }
            if {[file exists $logFile.sdds] && \
                  [string compare [exec sdds2stream -rows $logFile.sdds] "0 rows"]!=0} {
                catch {exec sddsprintout $logFile.sdds $logFile -column}
            } 
            set logFile $apsSCRSnapDir/$machine/$logFile
            # catch {file delete $logFile.sdds}
        } else {
            if $SCRdebug {puts stderr "Using sddscasr to take snapshot."}
            if [catch {exec sddscasr -save $tmpReqFile $snapshot "-description=$description" \
                         -pend=$pendIOTime -logFile=$logFile -waveform=onefile,savewaveform } result] {
                if $SCRdebug { puts stderr "Error from sddscasr: $result" }
                cd $oldDir
		return -code error "Error from sddscasr save $tmpReqFile: \n$result"
            }
        }
        if ![file exists $snapshot] {
            cd $oldDir
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSSaveMachine: $snapshot does not exist, snapshot taken failed." 
        }
        file delete $tmpReqFile
        if $SCRdebug {
            puts stderr "Snapshot is $snapshot: [exec sdds2stream -rows $snapshot]"
        }
        if [catch {APSSCRCheckSnapshot -snapshot $snapshot -logFile $logFile \
                     -GPServer $apsSCRUseGPServer} result] {
            APSDeleteTmpFileList -ID $tmpID
            cd $oldDir
            return -code error "APSSaveMachine: APSSaveMachine: $result"
        }
        if {[file exists $logFile]} {
            if ![file size $logFile] {
                file delete $logFile
            } else {
                cd $oldDir
                return -code ok [list $snapshot $logFile]
            }
        }
        catch {file delete ${snapshot}~}
        APSDeleteTmpFileList -ID $tmpID
        cd $oldDir
        return -code ok $snapshot
    } else {
        # permanent snapshot
        if $SCRdebug {
            puts stderr "Doing save with [file tail $requestFile] to $snapshot"
        }
        if [string length $statusCallback] {
            eval $statusCallback {"Doing save with [file tail $requestFile] to $snapshot"}
        }
        set time0 [format %.0lf [lindex $timeList 8]]
        if $apsSCRUseGPServer {
            if $SCRdebug {
                puts stderr "Using GPServer to take snapshot."
                puts stderr "request file: $requestFile [exec sddscheck $requestFile]"
            }
            catch {exec tclcaGPServer &}
            set logFile $snapshot.log 
            if $SCRdebug {
                puts stderr "Snapshot file is $snapshot"
                puts stderr "Logfile is $logFile"
                puts stderr "PWD is [pwd]"
            }
            if [catch {exec tclcaget -requestFile $requestFile \
                         -logFile $logFile.sdds -pipe out \
                         | sddsprocess -pipe=in $snapshot \
                         "-redefine=column,Count,1,type=long" \
                         "-reprint=column,Lineage,-" \
                         "-reprint=column,BackupMsg,-" \
                         "-reprint=column,RestoreMsg,-" \
                         "-reprint=column,ControlType,pv" \
                         "-reprint=column,ControlMode,-" \
                         "-reprint=parameter,SnapshotDescription,$description" \
                         "-reprint=parameter,RequestFile,$requestFile" \
                         "-reprint=parameter,SnapshotFilename,${snapshot}"} result] {
                if $SCRdebug { puts stderr "Error from GPServer: $result" }
            }
            if {[file exists $logFile.sdds] && \
                  [string compare [exec sdds2stream -rows $logFile.sdds] "0 rows"]!=0} {
                catch {exec sddsprintout $logFile.sdds $logFile -column}
            }
            set logFile $apsSCRSnapDir/$machine/$logFile
            # catch {file delete $logFile.sdds}
        } else {
            if [catch {exec sddscasr $requestFile $snapshot -save -pend=$pendIOTime \
                         -logFile=$logFile "-description=$description" -waveform=onefile,savewaveform } result] {
                if $SCRdebug {
                    puts stderr "Problem doing sddscasr: $result"
                }
                cd $oldDir
		return -code error "Problem doing sddscasr save $requestFile: \n$result"
            }
            if $SCRdebug {
                if ![file exists $snapshot] {
                    puts stderr "Snapshot should be $snapshot--NOT FOUND"
                } else {
                    puts stderr "$snapshot was found."
                }
            }
        }
        catch {file delete ${snapshot}~}
        if ![file exists $snapshot] {
            cd $oldDir
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSSaveMachine: $result" 
        }
        if $SCRdebug {
            puts stderr "Snapshot taken."
        }
        if [string length $statusCallback] {
            eval $statusCallback {"Snapshot taken."}
        }
        set action "save"
        if $routine {
            set action "save-routine"
        }
        if {[catch {APSSCRLogAction -file $snapshot -action $action} result] && \
              [string length $statusCallback]} {
            eval $statusCallback {"$result"}
        }
    }
    if $SCRdebug {
        puts stderr "Snapshot is $snapshot: [exec sdds2stream -rows $snapshot]"
    }
    if [catch {APSSCRProcessSnapshot -snapshot $snapshot -statusCallback $statusCallback \
                 -logFile $logFile \
                 -requestFile $requestFile} result] {
        cd $oldDir
        return -code error "APSSaveMachineByCasr: $result"
    }
    cd $oldDir
    return $result
}

#this procedure is to replace APSSaveMachine for saving snapshot
proc APSSaveMachineByCasr {args} {
    global apsSCRRequestDir apsSCRSnapDir SCRdebug 
    global apsSCRUseCASRServer apsSCRFirstSnapshot apsSCRSnapshotLogFile
    set machine ""
    set description ""
    set snapshot ""
    set temporary 0
    set requestFile ""
    set statusCallback "APSNoOp"
    set routine 0
    set pendIOTime 80
    set pingTimeOut 70
    if [APSStrictParseArguments {machine description snapshot temporary requestFile \
                                   statusCallback routine \
                                   pendIOTime pingTimeOut}] {
        return -code error "APSSaveMachineByCasr1: bad arguments"
    }
    if ![file exists [file join $apsSCRRequestDir $machine.req]] {
        return -code error "APSSaveMachineByCasr2: Bad machine name $machine" 
    }
    if ![string length $requestFile] {
        set requestFile ${apsSCRRequestDir}/${machine}.req 
    }
    if {$machine=="XrayTranslation"} {
        set sys XrayTr
    } else {
        set sys $machine
    } 
    if $apsSCRUseCASRServer {
        if [catch {APScagetTextFromWaveform -pvName ${sys}:ScrFilenameWF } initialOutput] {
            return -code error "APSSaveMachineByCasr3: unable to get the output file PV - ${sys}:ScrFilenameWF: $initialOutput"
        }
        if [catch {APScaputTextToWaveform -pvName ${sys}:ScrFilenameWF -text ""} result] {
            return -code error "APSSaveMachineByCasr4: unable to set the output file PV - ${sys}:ScrFilenameWF: $result"
        }
        #check casr RunControl for using casr server 
        if [catch {APSSCRCheckCasrRunControl -machine $machine -initialOutput $initialOutput} result] {
            return -code error "APSSaveMachineByCasr5:  $result"
        }
    }
    #setup the description pv and inputfile pv, clear the output file pv
    #initialize the output file PV
    
    if [catch {APScaputTextToWaveform -pvName ${sys}:ScrDescriptWF -text $description} result] {
        return -code error "APSSaveMachineByCasr6: unable to set the description PV- ${sys}:ScrDescriptWF: $result"
    }
    if [catch {APScaputTextToWaveform -pvName ${sys}:ScrInputFileWF -text $requestFile} result] {
        return -code error "APSSaveMachineByCasr7: unable to set the inputfile PV- ${sys}:ScrInputFileWF: $result"
    }
    if !$apsSCRUseCASRServer {
        #one time saving
        if [catch {APSCASRSaveMachine -machine $machine -pendIOTime $pendIOTime -pingTimeOut $pingTimeOut \
                     -routine $routine -temporary $temporary -snapshot $snapshot \
                     -statusCallback $statusCallback } result] {
            return -code error "APSSaveMachineByCasr8: $result"
        }
        return $result
    }
    #saving with daemon mode 
    
    if $apsSCRFirstSnapshot($machine) {
        exec medm -x -attach -macro RCPV=${sys}:ScrRunControlRC ./sr/psApp/APSRunControlSingle.adl &
        if [catch {APSCASRSaveMachine -machine $machine -snapshot $snapshot \
                     -statusCallback $statusCallback -daemon 1 -temporary $temporary \
                     -pendIOTime $pendIOTime -pingTimeOut $pingTimeOut \
                     -logFile $apsSCRSnapshotLogFile($machine) } result] {
            if [catch {APSSCRAbortCASRRunControl -machine $machine} result1] {
                return -code error "APSSaveMachineByCasr9:  $result1"
            }
            return -code error "APSSaveMachineByCasr:  $result"
        }
       # puts "first snapshot..."
        set apsFirstSnapshot($machine) 0
    } else {
        if [file exist $apsSCRSnapshotLogFile($machine)] {
            exec rm $apsSCRSnapshotLogFile($machine)
        }
        if [catch {exec cavget -list=${sys}:ScrRunControlRC.RUN -pend=10} running] {
            return -code error  "APSSaveMachineByCasr10: can not read ${sys}:ScrRunControlRC.RUN : $running"
        }
        if {$running=="?"} {
            return -code error "APSSaveMachineByCasr11: channel access error for ${sys}:ScrRunControlRC"
        }
        if !$running {
            return -code error "APSSaveMachineByCasr12: $sys:ScrRunControl is not running!"
        }
        if [catch {exec cavput -list=${sys}:ScrSaveSignalBO=1 -pend=10} result] {
            #abort sddscasr
            if [catch {APSSCRAbortCASRRunControl -machine $machine} result1] {
                return -code error "APSSaveMachineByCasr13:  $result1"
            }
            return -code error "APSSaveMachineByCasr14: $result"
        }
    }
    set error 1
    set timeout [expr [clock seconds] + $pendIOTime]
    while {[clock seconds]<$timeout} {
        if [catch {exec cavget -list=${sys}:ScrRunControlRC.RUN -pend=10} running] { 
            return -code error "APSSaveMachineByCasr15: $running"
        }
        if [catch {APScagetTextFromWaveform -pvName ${sys}:ScrFilenameWF} outputFile] { 
            return -code error "APSSaveMachineByCasr16: $outputFile"
        }
        if {$running=="?"} {
            return -code error "APSSaveMachineByCasr17: channel access error of ${sys}:ScrRunControlRC.RUN"
        }
        if [catch {exec cavget -list=${sys}:ScrSaveSignalBO -pend=10 -num} done] {
            return -code error "APSSaveMachineByCasr18: $done"
        }
        if {!$done && [string length $outputFile] } {
            set error 0
            break
        }
        after 500
    }
    # puts "output file: $outputFile"
    if $error {
        if [file exist $apsSCRSnapshotLogFile($machine)] {
            APSFileDisplayWindow [APSUniqueName .] \
                -fileName  $apsSCRSnapshotLogFile($machine) -deleteOnClose 1 -width 100 \
                -comment "Log file for $machine" \
                -printCommand "enscript -r"
        }
        return -code error "APSSaveMachineByCasr19: Run time out for sddscasr. Snapshot taking failed (the server maybe busy!)"
    }
    set dir [file dirname $outputFile] 
    #puts stderr "outputfile: $outputFile, [string length $outputFile]"
    if {$dir=="."} {
        set snapshot $apsSCRSnapDir/$machine/$outputFile
    } else {
        set snapshot $outputFile
    }
    
    if ![file exists $snapshot] {
        # wait up to 10 seconds for the file system updating the new file
        set count 0
        while {$count<20} {
            if ![file exists $snapshot] {
                after 1000
            } else {
                break
            }
            incr count
        }
       # puts $snapshot
        if ![file exists $snapshot] {
            return -code error "APSSaveMachineByCasr20: \n\n$snapshot does not exist,\n the server may have been busy; Please make another save."
        }
    }
    if [string length $statusCallback] {
        eval $statusCallback {"Snapshot taken"}
    }
    if $temporary {
        set fileList [glob -nocomplain ${snapshot}*]
        APSAddToTmpFileList -ID tempSave -fileList $fileList
        set logFile $apsSCRSnapshotLogFile($machine)
        
        if [catch {APSSCRCheckCASRSnapshot -snapshot $snapshot -logFile $logFile } result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSSaveMachineByCasr21: $result"
        }
        if {[file exists $logFile]} {
            if ![file size $logFile] {
                file delete $logFile
            } else {
                return -code ok [list $snapshot $logFile ]
            }
        }
        catch {file delete ${snapshot}~}
        return -code ok $snapshot
    }
    if [catch {APScagetTextFromWaveform -pvName ${sys}:ScrInputFileWF} requestFile] { 
        return -code error "APSSaveMachineByCasr22: $requestFile"
    }
    if [catch {APSSCRProcessSnapshot -snapshot $snapshot -statusCallback $statusCallback \
                 -logFile $apsSCRSnapshotLogFile($machine) \
                 -requestFile $requestFile} result] {
        return -code error "APSSaveMachineByCasr23: $result"
    }
    return $result
}

#this procedure is for saving snapshot one time or the first time for using sddscasr server 
proc APSCASRSaveMachine {args} {
    global apsSCRRequestDir apsSCRSnapDir SCRdebug 
    global apsSCRUseCASRServer
    set machine ""
    set snapshot ""
    set temporary 0
    set statusCallback "APSNoOp"
    set routine 0
    set pendIOTime 80
    set pingTimeOut 70
    set logFile ""
    set daemon 0
    if [APSStrictParseArguments {machine snapshot temporary \
                                   statusCallback routine \
                                   pendIOTime pingTimeOut logFile daemon }] {
        return -code error "APSSaveMachine: bad arguments"
    }
    
    set oldDir [pwd]
    cd [file join $apsSCRSnapDir $machine]

    if $SCRdebug {
        puts stderr "Directory changed to [pwd]"
    }
    if {[string length $snapshot]==0} {
        set snapshot [APSSCRMakeSnapshotFilename -machine $machine]
        set timeList [lrange $snapshot 1 end]
        set snapshot [lindex $snapshot 0]
    } else {
        catch {exec timeconvert -now} timeList 
    }
    if ![string length $logFile] {
        set logFile /tmp/[APSTmpString].burtlog
    }
    if {$machine=="XrayTranslation" } {
        set sys XrayTr
    } else {set sys $machine}
    set tmpID [APSUniqueName tmpID]
    if [catch {APScagetTextFromWaveform -pvName ${sys}:ScrInputFileWF} requestFile] {
        return -code error "APSCASRSaveMachine: unable to get the inputfile PV- ${sys}:ScrInputFileWF: $requestFile"
    }
    if [catch {APScaputTextToWaveform -pvName ${sys}:ScrFilenameWF -text ""} result] {
        return -code error "APSCASRSaveMachine: unable to set the outputfile PV - ${sys}:ScrFilenameWF: $result"
    }
    if $temporary {
        if $daemon {
            if $SCRdebug {
                puts stderr "Using sddscasr daemon mode to take snapshot."
            }
            set snapshot $machine
            set dir $apsSCRSnapDir/$machine
            if [catch {exec sddscasr -pend=$pendIOTime $requestFile -waveform=onefile,savewaveform \
                         -save -inputFilePV=${sys}:ScrInputFileWF \
                         $snapshot -dailyFiles -casavePV=${sys}:ScrSaveSignalBO \
                         -daemon -runControlPV=string=${sys}:ScrRunControlRC,pingTimeOut=$pingTimeOut \
                         "-runControlDesc=string=take snapshot" \
                         "-description=pv=${sys}:ScrDescriptWF" -logFile=$logFile \
                         -outputFilePV=${sys}:ScrFilenameWF & } result] {
                return -code error "APSCASRSaveMachine: $result"
            }
            after 10000
            if [catch {exec cavget -list=${sys}:ScrRunControlRC.RUN -pend=10} run] {
                return -code error "APSCASRSaveMachine: $run"
            }
            if {$run=="?"} {
                return -code error "APSCASRSaveMachine: channel access error for ${sys}:ScrRunControlRC"
            }
            if !$run {
                return -code error "APSCASRSaveMachine: ${sys}:RunControlRC is not running, problem with taking snapshot!"
            }
            cd $oldDir
            return daemon
        } else {
            if $SCRdebug {puts stderr "Using sddscasr to take snapshot."}
            if [catch {exec sddscasr  $requestFile -waveform=onefile,savewaveform \
                         -pend=$pendIOTime -save -inputFilePV=${sys}:ScrInputFileWF $snapshot \
                         -logFile=$logFile -description=pv=${sys}:ScrDescriptWF} result] {
                return -code error "APSCASRSaveMachine save $requestFile: \n$result"
            }
        }
        if ![file exists $snapshot] {
            cd $oldDir
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSCASRSaveMachine: $result" 
        }
        if $SCRdebug {
            puts stderr "Snapshot is $snapshot: [exec sdds2stream -rows $snapshot]"
        }
        if [catch {APSSCRCheckCASRSnapshot -snapshot $snapshot -logFile $logFile } result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSCASRSaveMachine: APSSaveMachine: $result"
        }
        if {[file exists $logFile]} {
            if ![file size $logFile] {
                file delete $logFile
            } else {
                return -code ok [list $snapshot $logFile]
            }
        }
        catch {file delete ${snapshot}~}
        APSDeleteTmpFileList -ID $tmpID
        return -code ok $snapshot
    } else {
        # permanent snapshot
        if $SCRdebug {
            puts stderr "Doing save for $machine system to $snapshot"
        }
        if [string length $statusCallback] {
            eval $statusCallback {"Doing save with $machine.req to $snapshot"}
        }
        set time0 [format %.0lf [lindex $timeList 8]]
        if $daemon {
            if $SCRdebug {
                puts stderr "Using sddscasr daemon mode to take snapshot."
            }
            set dirname [file dirname $snapshot]
            if {[string compare $dirname "."]==0} {
                set snapshot $machine
                set dir $apsSCRSnapDir
            } else {
                set snapshot $dirname/$machine
                set dir $dirname
            }
            if $SCRdebug {
                puts stderr "Logfile is $logFile"
                puts stderr "PWD is [pwd]"
            }
            if [catch {exec  sddscasr $requestFile \
                         -pend=$pendIOTime \
                         -save -inputFilePV=${sys}:ScrInputFileWF -waveform=onefile,savewaveform \
                         $snapshot -dailyFiles -casavePV=${sys}:ScrSaveSignalBO \
                         -daemon -runControlPV=string=${sys}:ScrRunControlRC,pingTimeOut=$pingTimeOut \
                         "-runControlDesc=string=take snapshot"  \
                         "-description=pv=${sys}:ScrDescriptWF" -logFile=$logFile  \
                         -outputFilePV=${sys}:ScrFilenameWF &
                after 1000 } result] {
                return -code error "APSCASRSaveMachine: $result"
            }
            after 10000
            if [catch {exec cavget -list=${sys}:ScrRunControlRC.RUN -pend=30} run] {
                return -code error $run
            }
            if !$run {
                return -code error "${sys}:RunControlRC is not running, problem with taking snapshot!"
            }
            cd $oldDir
            return daemon
        } else {
            if [catch {exec sddscasr  -waveform=rootname=$snapshot,directory=$apsSCRSnapDir \
                         -pend=$pendIOTime -save -inputFilePV=${sys}:ScrInputFileWF -pipe=out \
                         "-description=pv=${sys}:ScrDescriptWF" -logFile=$logFile -waveform=onefile,savewaveform \
                         | sddsprocess -pipe=in $snapshot \
                         -redefine=par,Time,$time0,units=s,type=long \
                         -reprint=par,SnapshotFilename,$snapshot } result] {
                if $SCRdebug {
                    puts stderr "Problem doing sddscasr: $result"
                }
		return -code error "Problem doing sddscasr save: $result"
            }
            catch {file delete ${snapshot}~}
        }
        if ![file exists $snapshot] {
            cd $oldDir
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSCASRSaveMachine: $result" 
        }
        if $SCRdebug {
            puts stderr "Snapshot taken."
        }
        if [string length $statusCallback] {
            eval $statusCallback {"Snapshot taken."}
        }
        set action "save"
        if $routine {
            set action "save-routine"
        }
        if {[catch {APSSCRLogAction -file $snapshot -action $action} result] && \
              [string length $statusCallback]} {
            eval $statusCallback {"$result"}
        }
    }
    
    if [catch {APSSCRProcessSnapshot -snapshot $snapshot -statusCallback $statusCallback \
                 -logFile $logFile \
                 -requestFile $requestFile} result] {
        return -code error $result
    }
    return $result
}

proc APSSCRCheckCasrRunControl {args} {
    set machine ""
    set initialOutput ""
    APSStrictParseArguments {initialOutput machine}
    
    global apsSCRFirstSnapshot apsSCRSnapshotLogFile
    if {$machine=="XrayTranslation"} {
        set sys XrayTr
    } else {
        set sys $machine
    }
    
    if [catch {exec cavget -list=${sys}:ScrRunControlRC.RUN -pend=10} running] {
        return -code error "${sys}:ScrRunControlRC.RUN: $running"
    }
    if {$running=="?"} {
        return -code error "APSSCRCheckCasrRunControl: Channel access error for ${sys}:ScrRunControlRC.RUN"
    }
    
    if ![info exist apsSCRSnapshotLogFile($machine)] {
        set apsSCRSnapshotLogFile($machine) /tmp/[APSTmpString].${machine}.log
    }
    if $running {
        set apsSCRFirstSnapshot($machine) 0
        if [catch {exec cavget -list=${sys}:ScrRunControlRC.MSG -pend=10} message] {
            return -code error "APSSCRCheckCasrRunControl: $message"
        }
        if {$message=="?"} {
            return -code error "APSSCRCheckCasrRunControl: Channel access error for ${sys}:ScrRunControlRC.MSG"
        }
        if ![string match "*sleeping*" $message] {
            return -code error "APSSCRCheckCasrRunControl: sddscasr server is busy now, please wait a few seconds!"
        }
        if [catch {exec cavget -list=${sys}:ScrSaveSignalBO -pend=10 -num} taking] {
            return -code error "APSSCRCheckCasrRunControl: $taking"
        }
        if $taking {
            return -code error "APSSCRCheckCasrRunControl: sddscasr server is taking data now, please wait a few seconds!"
        }
        if [catch {APScagetTextFromWaveform -pvName ${sys}:ScrFilenameWF } output] {
            return -code error "APSSCRCheckCasrRunControl: unable to get the output file PV - ${sys}:ScrFilenameWF: $initialOutput"
        }
     #   if [string compare $initialOutput $output]!=0 {
     #       return -code error "APSSCRCheckCasrRunControl: sddscasr server is taking data now, please wait a few seconds!"
     #   }
    } else {
        set apsSCRFirstSnapshot($machine) 1
    }
}

proc APSSCRAbortCASRRunControl {args} {
    set machine ""
    set statusCallback ""
    global apsSCRFirstSnapshot
    APSStrictParseArguments {machine statusCallback}
    if {$machine=="XrayTranslation"} {
        set sys XrayTr
    } else {
        set sys $machine
    }
    if [catch {exec cavput -list=${sys}:ScrRunControlRC.ABRT=1 -pend=10} result] {
        return -code error "APSSCRAbortCASRRunControl: Unable to abort ${sys}:ScrRunControlRC: $result"
    }
    #clear record
    if [catch {APSClearRCRecord -controlPV ${sys}:ScrRunControlRC -statusCallback $statusCallback } result] {
        return -code error "APSSCRAbortCASRRunControl: ${sys}:ScrRunControlRC record is not cleared: $result; Abort failed"
    }
    if [string length $statusCallback] {
        eval $statusCallback {"${sys}:ScrRunControlRC is aborted."}
    }
    set apsSCRFirstSnapshot($machine) 1
}

proc APSSCRProcessSnapshot {args} {
    set SCRdebug 0
    set snapshot ""
    set logFile ""
    set statusCallback "APSNoOp"
    set requestFile ""
    APSStrictParseArguments {SCRdebug snapshot logFile statusCallback requestFile}
    
    if {![string length $snapshot]} {
        return -code error "APSSCRProcessSnapshot: snapshot file is not provided!"
    }
    if ![file exist $snapshot] {
        return -code error "APSSCRProcessSnapshot:snapshot $snapshot file does not exist!"
    }
    if {![string length $requestFile]} {
        return -code error "APSSCRProcessSnapshot:requestFile is not provided!"
    }
    if ![file exist $requestFile] {
        return -code error "APSSCRProcessSnapshot:requestFile $requestFile file does not exist!"
    }
    
    if $SCRdebug {
        puts stderr "Snapshot is $snapshot: [exec sdds2stream -rows $snapshot]"
    }
    set filename [file tail $snapshot]
    set pathname [file dirname $snapshot]
    
    if [string length $statusCallback] {
        eval $statusCallback {"Compressing and processing snapshot..."}
    }
    
    catch {file delete $snapshot.gz}
    if [catch {exec gzip $snapshot} result] {
        return -code error "APSSCRProcessSnapshot: error gzipping snapshot: $result"
    }
    if [file exist $snapshot.waveform] {
        if [catch {exec gzip $snapshot.waveform} result] {
            return -code error "APSSCRProcessSnapshot: error gzipping snapshot: $result"
        }
    }
#    catch {exec chmod -w [glob ${snapshot}*]}
    catch {exec chmod -w ${snapshot}.gz}
    set snapshot $snapshot.gz
    
    if $SCRdebug {puts stderr "Launching collapse process"}
    if {[file exists $pathname/collapsed]} {
        exec sddscollapse $snapshot $pathname/collapsed/c$filename &
    } else {
        exec sddscollapse $snapshot $pathname/c$filename &
    }
    
    set reqRoot $requestFile
    if {[file exists $pathname/categories]} {
        set categoryPathname $pathname/categories
    } else {
        set categoryPathname $pathname
    }
    if {![file exists ${reqRoot}.categories]  || \
          [file mtime ${reqRoot}.categories]<=[file mtime ${reqRoot}]} {
        if $SCRdebug {puts stderr "Launching category sort process"}
        exec sddssort $snapshot -column=Category -unique $categoryPathname/categ$filename  &
    } else {
        exec cp ${reqRoot}.categories $categoryPathname/categ$filename
    }

    if {[catch {exec sddsprocess -nowarn "-filter=column,Count,0,1.5,!" $categoryPathname/categ$filename -pipe=out | sdds2stream -pipe=in -col=IndirectName} waveformFiles]} {
        set waveformFiles ""
    }
    foreach waveformFile $waveformFiles {
        catch {exec chmod -w $pathname/${filename}.$waveformFile}
    }

    if {[file exists $pathname/beamlines]} {
        set beamlinePathname $pathname/beamlines
    } else {
        set beamlinePathname $pathname
    }
    if {![file exists ${reqRoot}.beamlines]  || \
          [file mtime ${reqRoot}.beamlines]<=[file mtime ${reqRoot}]} {
        if $SCRdebug {puts stderr "Launching beamline sort process"}
        exec sddssort $snapshot -column=Beamline -unique $beamlinePathname/beam$filename  &
    } else {
        exec cp ${reqRoot}.beamlines $beamlinePathname/beam$filename
    }
    if [catch {APSSCRCheckCASRSnapshot -snapshot $snapshot -logFile $logFile} badrows] {
        return -code error "APSSCRProcessSnapshot: $badrows"
    }
    if $badrows {
        #display log file
        if [file exist $logFile] {
            set tmpfile $logFile
        } else {
            set tmpfile /tmp/[APSTmpString]
            APSAddToTmpFileList -ID 1 -fileList $tmpfile
            if [catch {exec sddsprocess $snapshot -match=col,CAError=y -pipe=out \
                         sddsprintout -pipe=in "-title=Problem in reading following PVs..." \
                         -col=ControlName $tmpfile} result] {
                return -code error $result
            }
        }
    }
    if {[file exists $logFile] && $badrows} {
        if ![file size $logFile] {
            file delete $logFile
        } else {
            return -code ok [list $snapshot $logFile]
        }
    }
    return -code ok $snapshot
}

# Checks a sddscasr snapshot for bad data, returning the number of bad rows.
# Puts a line in the logFile with this info, also.
proc APSSCRCheckCASRSnapshot {args} {
    set snapshot ""
    set logFile ""
    APSStrictParseArguments {snapshot logFile}
    if ![file exists $snapshot] {
        return -code error "APSSCRCheckCASRSnapshot: not found: $snapshot"
    }
    set tmpfile /tmp/[APSTmpString]
    if [catch {exec sddsprocess $snapshot -match=col,CAError=y -pipe=out -nowarnings \
                 | sddsconvert -pipe=in $tmpfile -retain=col,ControlName -nowarning } result] {
        return -code error "APSSCRCheckCASRSnapshot: $result"
    }
    set rows [exec sdds2stream $tmpfile -rows=bar]
    if $rows {
        if ![file exist $logFile] {
            if [catch {exec sddsprintout $tmpfile $logFile \
                         -col=ControlName "-title=Missing $rows PVs..." } result] {
                return -code error "APSSCRCheckCASRSnapshot: $result"
            }
        }
        file delete -force $tmpfile
        if [catch {exec echo "\nAPSSCRCheckCASRSnapshot: $rows missing PVs\n" >> $logFile} result] {
            return -code error "APSSCRCheckCASRSnapshot: $result"
        }
    }

    if [catch {exec sddsprocess $snapshot -pipe=out \
                 -nowarning "-match=column,IsNumerical=y,ValueString=,&" \
                 | sdds2stream -pipe -rows,bare} result] {
        return -code error "APSSCRCheckCASRSnapshot: $result"
    } else {
        if {$result > 0} {
            APSSendEMail -address soliday@aps.anl.gov \
              -subject "Invalid SCR snapshot data" \
              -message "Look at $snapshot there may be an IOC that needs a reboot"
            APSSendEMail -address shang@aps.anl.gov \
              -subject "Invalid SCR snapshot data" \
              -message "Look at $snapshot there may be an IOC that needs a reboot"
            if [catch {exec echo "\nAPSSCRCheckCASRSnapshot: $rows missing PVs. Contact Bob Soliday or Hairong Shang to check for IOC problems.\n" > $logFile} result] {
                return -code error "APSSCRCheckCASRSnapshot: $result"
            }
            return -code error "APSSCRCheckCASRSnapshot: Invalid data in snapshot. There is probably an IOC with a hung task. Please contact Bob Soliday or Hairong Shang"
        }
    }

    return $rows
}

# Checks a snapshot for bad data, returning the number of bad rows.
# Puts a line in the logFile with this info, also.
proc APSSCRCheckSnapshot {args} {
    set snapshot ""
    set logFile ""
    set GPServer 0
    APSStrictParseArguments {snapshot logFile GPServer}
    if ![file exists $snapshot] {
        return -code error "APSSCRCheckSnapshot: not found: $snapshot"
    }
    if $GPServer {
        set matchOptions -match=column,ValueString=-,ValueString=,|
    } else {
        set matchOptions -match=column,ControlName=,ControlType=,|,CAError=y,|
    }
    if [catch {exec sddsprocess $snapshot -pipe=out \
                 $matchOptions -nowarning \
                 | sdds2stream -rows -pipe} result] {
        return -code error "APSSCRCheckSnapshot: $result"
    }
    set rows [lindex [split $result] 0]
    if $rows {
        if {[file exists $logFile]} {
            if [catch {exec echo "\nAPSSCRCheckSnapshot: $rows missing PVs\n" >> $logFile} result] {
                return -code error "APSSCRCheckSnapshot: $result"
            }
        } else {
            if [catch {exec echo "\nAPSSCRCheckSnapshot: $rows missing PVs\n" > $logFile} result] {
                return -code error "APSSCRCheckSnapshot: $result"
            }
        }
    }

    if [catch {exec sddsprocess $snapshot -pipe=out \
                 -nowarning "-match=column,IsNumerical=y,ValueString=,&" \
                 | sdds2stream -pipe -rows,bare} result] {
        return -code error "APSSCRCheckSnapshot: $result"
    } else {
        if {$result > 0} {
            APSSendEMail -address soliday@aps.anl.gov \
              -subject "Invalid SCR snapshot data" \
              -message "Look at $snapshot there may be an IOC that needs a reboot"
            APSSendEMail -address shang@aps.anl.gov \
              -subject "Invalid SCR snapshot data" \
              -message "Look at $snapshot there may be an IOC that needs a reboot"
            if [catch {exec echo "\nAPSSCRCheckSnapshot: $rows missing PVs. Contact Bob Soliday or Hairong Shang to check for IOC problems.\n" > $logFile} result] {
                return -code error "APSSCRCheckSnapshot: $result"
            }
            return -code error "APSSCRCheckSnapshot: Invalid data in snapshot. There is probably an IOC with a hung task. Please contact Bob Soliday or Hairong Shang"
        }
    }
    
    return $rows
}

proc APSCompareMachine {args} {
    global apsSCRSnapDir apsSCRRequestDir SCRdebug
    set snap1Label ""
    set machine ""
    set snapshot1 ""
    set snapshot2 ""
    set graphics 0
    set percentTolerance 0
    set absoluteTolerance 0
    set sortChoice none
    set statusCallback "APSNoOp"
    set showSimilarities 0
    set customComparisonList {}
    set pendIOTime 80
    #following arguments are for SRXrayBPM system custom compare
    set gapDiffTolerance 0.1
    set posDiffTolerance 0.1
    set minVoltage 0.01
    set waveformFile1 ""
    set waveformFile2 ""
    #minVoltage is the minimum acceptable blade voltage
    set partial 0
    if $SCRdebug { puts stderr "in APSCompareMachine" }
    if {[APSStrictParseArguments {snap1Label machine snapshot1 snapshot2 graphics statusCallback partial \
                                    percentTolerance absoluteTolerance sortChoice \
                                    showSimilarities customComparisonList \
                                    gapDiffTolerance posDiffTolerance minVoltage pendIOTime \
                                    waveformFile1 waveformFile2 \
                                } ]==-1} {
        return -code error "Bad arguments to APSCompareMachine"
    }
    if $SCRdebug { puts stderr "Parsing done."}
    
    if $absoluteTolerance>0 {
        set percentTolerance 0
    }
    if ![string length $snapshot2] {
        if ![file exists [file join $apsSCRRequestDir $machine.req]] {
            return -code error "APSCompareMachine: Bad machine name $machine"
        }
    } 
    set tmproot /tmp/[APSTmpString]
    APSAddToTmpFileList -ID APSCompareMachine -fileList $tmproot
    APSAddToTmpFileList -ID APSCompareMachineError -fileList $tmproot
    
    # snapshot1 needs $apsSCRSnapDir/$machine path 
#    set snapshot1 $apsSCRSnapDir/$machine/$snapshot1
    set waveform1 [file root $snapshot1].waveform
    if ![file exist $waveform1] {
        set waveform1 $waveform1.gz
    }
    if ![file exists $snapshot1] {
        set snapshot1 ${snapshot1}.gz
    }
    if ![file exists $snapshot1] {
        return -code error "APSCompareMachine: snapshot1 file $snapshot1 does not exist"
    }
    if $SCRdebug { puts stderr "Snapshot1 found."}
 
    if [string length $snapshot2]==0 {
        if $SCRdebug { puts stderr "Making snapshot2"}
        if [string length $statusCallback] {
            eval $statusCallback {"Making snapshot..."}
        }
        set snapshot2 ${tmproot}.snap2 
        if [catch {APSSaveMachine -machine $machine -temporary 1 -pendIOTime $pendIOTime \
		       -snapshot $snapshot2 \
		       -description "APSCompareMachine temporary snapshot" } result] {
            APSDeleteTmpFileList -ID APSCompareMachine
            return -code error "APSCompareMachine: Unable to make temporary snapshot: $result"
        }
        set snapshot2 [lindex $result 0]
	#keep only pvs that are in snapshot1
	if [catch {exec sddsselect $snapshot2 $snapshot1 $snapshot2.1 -match=ControlName } result] {
	    APSDeleteTmpFileList -ID APSCompareMachine
            return -code error "APSCompareMachine: Unable to select matching pvs: $result"
	}
	exec mv $snapshot2.1 $snapshot2
        if [string length $statusCallback] {
            eval $statusCallback {"Snapshot done."}
        }
        set DifferenceLabel Prsnt-Rfrnc
        set snap2Label "present configuration"
        set Value2Label "Present"
        set Value1Label "Reference"
        if $SCRdebug { puts stderr "snapshot2 is $snapshot2" }
        set snap2IsTmp 1
    } else {
        set DifferenceLabel Dtst2-Dtst1
        set snap2Label $snapshot2
        set Value1Label Dataset1
        set Value2Label Dataset2
        set snap2IsTmp 0
    }
    
    if ![file exists $snapshot2] {
        set snapshot2 ${snapshot2}.gz
    }
    if [string length $waveformFile1] {
        set waveform1 $waveformFile1
    }
    if [string length $waveformFile2] {
        set waveform2 $waveformFile2
    } else {
        set waveform2 [file root $snapshot2].waveform
        if ![file exist $waveform2] {
            set waveform2 $waveform2.gz
        }
    }
    if ![file exists $snapshot2] {
        APSDeleteTmpFileList -ID APSCompareMachine
        return -code error "APSCompareMachine: snapshot2 $snapshot2 does not exist"
    }
    if ![string length $snap1Label] {
        set snap1Label "$snapshot1"
    }
    if !$partial {
        if [catch {APSCompareNonMatchingPVs -snapshot1 $snapshot1 -snapshot2 $snapshot2 -snap1Label $snap1Label -snap2Label $snap2Label} result] {
            return -code error "APSCompareMachine: error in checking non-matching pvs: $result"
        }
    }
    if {[file exist $waveform1] && [file exist $waveform2]} {
        set tmpRoot /tmp/[APSTmpString]
        set waveforms [exec sdds2stream -par=WaveformPV $waveform1]
        set fileList ""
        set index 0
        foreach pv $waveforms {
            incr index
            if [catch {exec sddsprocess /home/helios/oagData/SCR/requestFiles/${machine}.req \
                         -match=col,ControlName=$pv -pipe=out \
                         | sdds2stream -pipe -col=Tolerance } tol] {
                return -code error "APSCompareMachine: unable to get the tolerance of $pv: $result"
            }
            if [catch {exec sddsprocess $waveform1 $tmpRoot.1a -match=par,WaveformPV=$pv
                exec sddsprocess $waveform2 $tmpRoot.2a -match=par,WaveformPV=$pv } result] {
                exec echo $pv does not exist in one of $waveform > $tmpRoot.index
            } else {
                if [catch {exec sddsconvert $tmpRoot.1a -rename=col,Waveform=Reference -pipe=out \
                             | sddsxref -pipe $tmpRoot.2a -rename=col,Waveform=Value \
                             | sddsprocess -pipe=in  $tmpRoot.diff$index -nowarn \
                             "-define=column,Difference,Value Reference -" \
                             "-define=col,AbsDiff,Difference abs" \
                             "-test=col,AbsDiff $tol >"  -nowarnings} result] {
                    return -code error "APSCompareMachine (waveform2) :$result"
                }
                set rows [lindex [exec sdds2stream -rows=bar $tmpRoot.diff$index] 0]
                if $rows {
                    exec sddsprintout $tmpRoot.diff$index $tmpRoot.$index \
                      "-title=Waveform $pv has $rows rows different (more than $tol) between $waveform1 and $waveform2" \
                      -col=Index -col=Value,label=$Value1Label -col=Reference,label=$Value2Label -col=Difference
                } else {
                    exec echo no difference of $pv between $waveform1 and $waveform2 \n\n > $tmpRoot.$index
                }
            }
            lappend fileList $tmpRoot.$index
        }
        if [llength $fileList]>1 {
            eval exec cat $fileList > $tmpRoot.print
            set printFile $tmpRoot.print
        } else {
            set printFile $fileList
        }
      
        APSFileDisplayWindow [APSUniqueName .] \
          -fileName $printFile -deleteOnClose 1 -width 120 -height 50 
    }
    
    if {[llength $customComparisonList]==0 \
          || ([llength $customComparisonList]==1 && \
                [string length [lindex $customComparisonList 0]]==0)} {
        if $SCRdebug {
            puts stderr "Doing normal comparison."
        }
        set printFile1 ${tmproot}-1
        set sdiffFile ${tmproot}-2
        set printFile2 ${tmproot}-3
        set diffFile ${tmproot}-4
        set bothSnaps ${tmproot}-5
        set enumDiff ${tmproot}-6

        APSAddToTmpFileList -ID APSCompareMachine -fileList "$bothSnaps $diffFile"
        APSAddToTmpFileList -ID APSCompareMachineError -fileList \
          "$sdiffFile $enumDiff $printFile1 $printFile2 $bothSnaps $diffFile"
        
        if $absoluteTolerance>0 {
            set redefToleranceArg "-redefine=column,Tolerance,$absoluteTolerance" 
            set toleranceLabel "\n  using absolute tolerance of $absoluteTolerance\n"
        } elseif $percentTolerance>0 {
            set redefToleranceArg "-redefine=column,Tolerance,Reference [expr $percentTolerance/100.0] * abs"
            set toleranceLabel "\n  using percent tolerance of $percentTolerance\n"
        } else {
            set redefToleranceArg "-filter=col,Tolerance,0,1e300"
            set toleranceLabel "\n  using default tolerances\n"
        }

        if [string length $statusCallback] {
            eval $statusCallback {"Doing comparison..."}
        }

        if {[catch {APSSCRLogAction -file [file tail $snapshot1] \
                      -action compare} result] && \
              [string length $statusCallback]} {
            eval $statusCallback {"$result"}
        }

        if {!$snap2IsTmp && \
              [catch {APSSCRLogAction -file [file tail $snapshot2] \
                        -action compare} result] && \
              [string length $statusCallback]} {
            eval $statusCallback {"$result"}
        }

        if $showSimilarities {
            set extraQualifier ""
            set compareType similarities
        } else {
            set extraQualifier ",!"
            set compareType differences
        }
        
        if [catch {exec sddsconvert $snapshot2 -pipe=out \
                     -rename=col,ValueString=NewValueString -binary -nowarn \
                     | sddsxref $snapshot1 -pipe -match=ControlName -take=* -nowarn -reuse=row \
                     | tee $bothSnaps \
                     | sddsprocess -pipe -nowarnings -match=col,IsNumerical=+y -nowarn "-match=col,ValueString=WaveformPV,!"  \
                     -numberTest=column,ValueString,strict \
                     -numberTest=column,NewValueString,strict \
                     "-scan=col,Value,NewValueString,%lf" \
                     "-scan=col,Reference,ValueString,%lf" \
                     $redefToleranceArg \
                     "-define=column,Difference,Value Reference -" \
                     | tee $diffFile \
                     | sddsprocess -pipe=in $sdiffFile -nowarn \
                     "-define=col,AbsDifference,Difference abs,format_string=%12.6f" \
                     "-define=col,ExcessDifference,AbsDifference Tolerance -" \
                     "-define=col,FracAbsDifference,Value abs Reference abs + 2 / sqrt 0 == pop ? -1 : AbsDifference swap / \$ " \
                     "-filter=col,ExcessDifference,-1e300,0$extraQualifier" } result] {
            return -code error "APSCompareMachine7: $result"
        }
            
        if [catch {exec sddsprocess $bothSnaps $enumDiff "-match=col,IsNumerical=+y,!" \
                     "-match=col,ValueString=@NewValueString$extraQualifier" -nowarning } result] {
            return -code error "APSCompareMachine8: $result"
        }

        catch {exec sdds2stream $sdiffFile -rows} rows
        exec echo $rows with significant $compareType > $printFile1
        switch -- $sortChoice {
            byValue {
                set sortArg -column=Reference,incr
            }
            byError {
                set sortArg -column=AbsDifference,decr
            }
            byName {
                set sortArg -column=ControlName
            }
            byFracError {
                set sortArg -column=FracAbsDifference,decr
            }
            default {
                set sortArg ""
            }
        }
        if [string length $sortArg] {
            set newDiff ${tmproot}-7
            if ![catch {exec sddssort $sdiffFile $newDiff $sortArg} result] {
                file rename -force $newDiff $sdiffFile
            }
        }

        if [string length $statusCallback] {
            eval $statusCallback {"Making printout..."}
        }


        exec sddsbreak $sdiffFile -pipe=out -rowlimit=42 \
          | sddsprintout -column=ControlName,format=%-30s -pipe \
          -nowarning -postpagelines=4 \
          "-title=Numerical $compareType between $snap1Label and $snap2Label $toleranceLabel"  \
          "-column=Reference,label=$Value1Label,format=%12.5g" \
          "-column=Value,label=$Value2Label,format=%12.5g" \
          "-column=Difference,label=$DifferenceLabel,format=%12.5g" \
          "-column=Tolerance,label=Toler.,format=%10.3g"  \
          "-col=Description,format=%-12s" \
          >> $printFile1

        catch {exec sdds2stream $enumDiff -rows} rows
        exec echo $rows with enumerated-value $compareType > $printFile2
        if [string compare $sortChoice byName]==0 {
            set newDiff ${tmproot}-8
            if ![catch {exec sddssort $enumDiff $newDiff $sortArg} result] {
                file rename -force $newDiff $enumDiff
            }
        }
        exec sddsbreak $enumDiff -rowlimit=42 -pipe=out \
          | sddsprintout -pipe -column=ControlName,format=%-30s \
          -postpagelines=4 -nowarning \
          "-title=Enumerated $compareType between $snap1Label and $snap2Label\n\n"  \
          "-column=ValueString,label=$Value1Label,format=%20s" \
          "-column=NewValueString,label=$Value2Label,format=%20s" \
          "-col=Description,format=%-12s" \
          >> $printFile2 

        if $graphics {
	    exec echo "\n\n" >> $tmproot.space
	    exec cat $printFile2 $tmproot.space $printFile1 > $tmproot
	    file delete -force $tmproot.space
            # display is done by this procedure
            APSFileDisplayWindow [APSUniqueName .] \
              -fileName $tmproot -deleteOnClose 1 -width 120 -height 50 \
              -comment "Numerical-value snapshot $compareType" \
              -printCommand "enscript -r"
            #APSFileDisplayWindow [APSUniqueName .] \
            #  -fileName $printFile2 -deleteOnClose 1 -width 120 -height 50 \
             # -comment "Enumerated-value snapshot $compareType" \
              #-printCommand "enscript -r"
            set doNotDelete 0
            switch $machine {
                PLET {
                    exec plotPLETcomparison $diffFile $enumDiff $tmproot \
                      $snap1Label $snap2Label 1 & 
                }
                default {
                    eval file delete $diffFile $enumDiff
                }
            }
            # file delete $sdiffFile $bothSnaps
            #after 120000 "APSDeleteTmpFileList -ID APSCompareMachineError"
           # return {}
        } else {
            file delete $bothSnaps $diffFile
            APSDeleteTmpFileList -ID APSCompareMachine
            return [list $sdiffFile $enumDiff $printFile1 $printFile2]
        }

    } else {
        # custom comparisons using caller-supplied procedures.
        if $SCRdebug {
            puts stderr "Doing [llength customComparisonList] custom comparison(s)."
            puts stderr "snapshot1: $snapshot1"
            puts stderr "snapshot2: $snapshot2"
            puts stderr "machine: $machine"
        }
        set results ""
        foreach customProc $customComparisonList {
            if {$machine=="SRXrayBPM"} {
                if [catch {eval $customProc -machine $machine -snapshot1 $snapshot1 \
                               -gapDiffTolerance $gapDiffTolerance \
                               -snapshot2 $snapshot2 -snap1Label \"$snap1Label\" \
                               -Value1Label \"$Value1Label\" -Value2Label \"$Value2Label\" \
                               -snap2Label \"$snap2Label\" -DifferenceLabel \"$DifferenceLabel\" \
                               -posDiffTolerance $posDiffTolerance -minVoltage $minVoltage } result] {
                    APSDeleteTmpFileList -ID APSCompareMachineError
                    return -code error "Problem with $customProc: $result"
                }     
            } else {
                if [catch {eval $customProc -machine $machine \
                             -snapshot1 $snapshot1 -snapshot2 $snapshot2} result] {
                    APSDeleteTmpFileList -ID APSCompareMachineError
                    return -code error "Problem with $customProc: $result"
                }
            }
            lappend results $result
        }
        return $results
    }
}

proc APSCompareNonMatchingPVs {args} {
    set snapshot1 ""
    set snapshot2 ""
    set snap1Label ""
    set snap2Label ""
    APSParseArguments {snapshot1 snapshot2 snap1Label snap2Label}
    set tmproot /tmp/[APSTmpString]
    
    #compare matching pvs, and display non-match pvs
    
    if [catch {exec sddsselect $snapshot1 $snapshot2 $tmproot.snap1n -match=ControlName -invert -nowarnings
	exec sddsselect $snapshot2 $snapshot1 $tmproot.snap2n -match=ControlName -invert -nowarnings } result] {
	return -code error "APSCompareMachine6a: $result"
    }
    set rows1 [exec sdds2stream -rows=bar $tmproot.snap1n]
    set rows2 [exec sdds2stream -rows=bar $tmproot.snap2n]
    if $rows1 {
	exec sddsbreak $tmproot.snap1n -pipe=out -rowlimit=42 \
	    | sddsprintout -column=ControlName,format=%-30s -pipe \
	    -nowarning -postpagelines=4 \
	    "-title=Non-matching pvs which exist in $snap1Label but not in $snap2Label"  \
	    "-column=ValueString,label=ValueInRef1,format=%-30s" \
	    "-col=Description,format=%-12s" \
	    >> $tmproot.printout.1n
	APSAddToTmpFileList -ID APSCompareMachine -fileList $tmproot.printout.1n
    }
    if $rows2 {
	exec sddsbreak $tmproot.snap2n -pipe=out -rowlimit=42 \
	    | sddsprintout -column=ControlName,format=%-30s -pipe \
	    -nowarning -postpagelines=4 \
	    "-title=Non-matching pvs which exist in $snap2Label but not in $snap1Label"  \
	    "-column=ValueString,label=ValueInRef2,format=%-30s" \
	    "-col=Description,format=%-12s" \
	    >> $tmproot.printout.2n
	APSAddToTmpFileList -ID APSCompareMachine -fileList $tmproot.printout.2n
	if $rows1 {
	    exec echo "\n\n" >> $tmproot.space1
	    exec cat  $tmproot.printout.1n $tmproot.space1 $tmproot.printout.2n > $tmproot.printNonmatch
	} else {
	    exec cp $tmproot.printout.2n  $tmproot.printNonmatch
	}
    } elseif $rows1 {
	exec cp $tmproot.printout.1n $tmproot.printNonmatch
    }
    if {$rows1 || $rows2} {
	APSFileDisplayWindow [APSUniqueName .] \
	    -fileName $tmproot.printNonmatch -deleteOnClose 1 -width 120 -height 50 \
	    -comment "Non-matching PVs in two snapshot" \
	    -printCommand "enscript -r"
	
    }
}
proc APSListSCRMatch {args} {
    global apsSCRRequestDir apsSCRSnapDir apsSCRAtticDir
    set machine ""
    set startYear 0
    set startDay 0
    set startMonth 0
    set endYear 0
    set endDay 0
    set endMonth 0
    set descriptionFragment "" 
    set statusCallback puts
    set parent ""
    set routine 0
    set shift 0
    set callback ""
    set height 10
    set listOrder increasing
    set selectMode single
    set attic 0
    set label ""
    set labelFont ""
    if [APSStrictParseArguments \
          {machine startYear startDay startMonth endYear endDay endMonth \
             descriptionFragment statusCallback height \
             parent routine shift callback listOrder selectMode attic label labelFont}]==-1 {
        return -code error "APSListSCRMatch: bad arguments"
    }
    if $routine {
        if {$shift} {
            set descriptionFragment "Routine save (shift change)"
        } else {
            set descriptionFragment "Routine save"
        }
        #set startYear 1990
        #set endYear 2090
        #set startDay 1
        #set endDay 1
        #set startMonth 1
        #set endMonth 1
    }
    
    if {[string length $descriptionFragment] == 0} {
        $statusCallback "Supply a description search string (use * for everything)"
        return
    }
    if {[winfo exists ${parent}.apsSCRlist]} {destroy ${parent}.apsSCRlist}
    if {[winfo exists ${parent}.apsSCRcateg]} {destroy ${parent}.apsSCRcateg}
    $statusCallback "Searching for $machine..." 
    set oldDir [pwd]
    set snapDir $apsSCRSnapDir/$machine
    if $attic {
        set snapDir $apsSCRAtticDir/$machine
    } 
    cd $snapDir
    if {[file exists collapsed]} {
        set collapsedDirectoryFound 1
        cd collapsed
    } else {
        set collapsedDirectoryFound 0
    }
    set fileList \
      [APSFindFilesBetweenDates -directory . -rootname c$machine -tailsOnly 1 \
         -startDateList \
         [APSFormatDate -year $startYear -month $startMonth -day $startDay \
            -twoDigitYear 0 -dateFormat list] \
         -endDateList \
         [APSFormatDate -year $endYear -month $endMonth -day $endDay \
            -twoDigitYear 0 -dateFormat list] \
         -extensionList {""}
       ]
    if [llength $fileList]==0 {
        $statusCallback "No match found for dates given."
        cd $oldDir
        return
    }
    set fileList [lsort -$listOrder $fileList]
    set listData /tmp/[APSTmpString]
    set tmpID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $tmpID -fileList $listData
    regsub -all {\[} ${descriptionFragment} {\[} descriptionFragment
    if [catch {eval exec sddscombine $fileList -pipe=out -merge \
                | sddsprocess -pipe=in $listData \
                 \"-match=col,SnapshotDescription=+*${descriptionFragment}*\" -nowarnings} result] {
        $statusCallback "Error scanning descriptions of snapshots!"
        APSAlertBox [APSUniqueName .] -errorMessage "$result" 
        APSDeleteTmpFileList -ID $tmpID
        cd $oldDir
        return
    }
    if {$collapsedDirectoryFound} {
        cd ..
    }
    if [catch {exec sdds2stream -rows $listData} result] {
        $statusCallback "Error reading list of matching snapshots"
        cd $oldDir
        APSDeleteTmpFileList -ID $tmpID
        return
    }
    set count [lindex [split $result] 0]
    if {$count == 0} {
        $statusCallback "No match to search criteria"
        cd $oldDir
        APSDeleteTmpFileList -ID $tmpID
        return
    }

    global apsSCRMakeLBoxTextLineMaxWidth
    set apsSCRMakeLBoxTextLineMaxWidth 0
    APSSDDSListbox .apsSCRlist -parent ${parent} -height $height -selectMode $selectMode \
      -widthLimit 120 -trim 1 -label $label -labelFont $labelFont \
      -fileName $listData -labelMaker APSSCRMakeLBoxTextLine -arrayName descriptionArray \
      -page 0 -callback $callback -columnList {SnapshotFilename TimeStamp SnapshotDescription} \
      -contextHelp "Double-click to select a snapshot" -doneButton 0

    $statusCallback "Pick a configuration to use"
    cd $oldDir
    APSDeleteTmpFileList -ID $tmpID
}

proc APSListSCRMatchSetArray {args} {
    global apsSCRRequestDir apsSCRSnapDir apsSCRSystem
    set machine $apsSCRSystem
    set startYear 0
    set startDay 0
    set startMonth 0
    set endYear 0
    set endDay 0
    set endMonth 0
    set descriptionFragment "" 
    set statusCallback puts
    set parent ""
    set routine 0
    set shift 0
    set callback ""
    set arrayName ""
    set PreferredOnly 0
    set height 10
    set listOrder increasing
    if [APSStrictParseArguments \
          {machine startYear startDay startMonth endYear endDay endMonth \
             descriptionFragment statusCallback height \
             parent routine shift callback arrayName PreferredOnly listOrder}]==-1 {
        return -code error "APSListSCRMatch: bad arguments"
    }
    set old_apsSCRSystem $apsSCRSystem
    set apsSCRSystem $machine
    set apsSCRSystem $old_apsSCRSystem

    if $routine {
        if {$shift} {
            set descriptionFragment "Routine save (shift change)"
        } else {
            set descriptionFragment "Routine save"
        }
        #set startYear 1990
        #set endYear 2090
        #set startDay 1
        #set endDay 1
        #set startMonth 1
        #set endMonth 1
    }
    
    if {[string length $descriptionFragment] == 0} {
        $statusCallback "Supply a description search string (use * for everything)"
        set apsSCRSystem $old_apsSCRSystem
        return
    }
    if {[winfo exists ${parent}.snaplist]} {destroy ${parent}.snaplist}
    if {[winfo exists ${parent}.apsSCRlist]} {destroy ${parent}.apsSCRlist}
    if {[winfo exists ${parent}.apsSCRcateg]} {destroy ${parent}.apsSCRcateg}
    $statusCallback "Searching for $machine..." 
    set oldDir [pwd]
    set snapDir $apsSCRSnapDir/$machine
    cd $snapDir
    if {[file exists collapsed]} {
        set collapsedDirectoryFound 1
        cd collapsed
    } else {
        set collapsedDirectoryFound 0
    }
    set fileList \
      [APSFindFilesBetweenDates -directory . -rootname c$machine -tailsOnly 1 \
         -startDateList \
         [APSFormatDate -year $startYear -month $startMonth -day $startDay \
            -twoDigitYear 0 -dateFormat list] \
         -endDateList \
         [APSFormatDate -year $endYear -month $endMonth -day $endDay \
            -twoDigitYear 0 -dateFormat list] \
         -extensionList {""}
       ]
    if {[llength $fileList] != 0} {
        set fileList [lsort -$listOrder $fileList]
        set listData /tmp/[APSTmpString]
        set tmpID [APSUniqueName tmpID]
        APSAddToTmpFileList -ID $tmpID -fileList $listData
        regsub -all {\[} ${descriptionFragment} {\[} descriptionFragment
        if [catch {eval exec sddscombine $fileList -pipe=out -merge \
                       | sddsprocess -pipe=in $listData \
                       \"-match=col,SnapshotDescription=+*${descriptionFragment}*\" -nowarnings} result] {
            $statusCallback "Error scanning descriptions of snapshots!"
            APSAlertBox [APSUniqueName .] -errorMessage "$result" 
            APSDeleteTmpFileList -ID $tmpID
            cd $oldDir
            set apsSCRSystem $old_apsSCRSystem
            return
        }
        if [catch {exec sdds2stream -rows $listData} result] {
            $statusCallback "Error reading list of matching snapshots"
            APSDeleteTmpFileList -ID $tmpID
            cd $oldDir
            set apsSCRSystem $old_apsSCRSystem
            return
        }
        set count [lindex [split $result] 0]
        if {$count == 0} {
            $statusCallback "No match to search criteria"
            APSDeleteTmpFileList -ID $tmpID
            cd $oldDir
            set apsSCRSystem $old_apsSCRSystem
            return
        }
    }
    if {$collapsedDirectoryFound} {
        cd ..
    }

    APSFrame .apsSCRlist -parent $parent -label "" -relief flat
    set w $parent.apsSCRlist.frame
    
    global apsSCRMakeLBoxTextLineMaxWidth apsSCRTopDirectory
    set apsSCRMakeLBoxTextLineMaxWidth 0
    global $arrayName
    set ${arrayName}(Filename) ""
    set ${arrayName}(ShortFilename) ""
    set ${arrayName}(Description) ""
    set ${arrayName}(IsPreferredFile) 0
    
    if {!$PreferredOnly} {
        if {[llength $fileList] != 0} {
            APSSDDSListbox .snaplist -parent $parent -height $height \
                -widthLimit 120 -trim 1 \
                -fileName $listData -labelMaker APSSCRMakeLBoxTextLine \
                -arrayName apsSCRMatchListArray$arrayName$machine \
                -page 0 -callback "APSListSCRMatchSetArrayCallback $machine apsSCRMatchListArray$arrayName$machine $callback 0 $arrayName " \
                -columnList {SnapshotFilename TimeStamp SnapshotDescription} \
                -contextHelp "Double-click to select a snapshot" -doneButton 0 \
                -label "Snapshot Choices"
        }
    }
    if {!$routine && [file exists [file join $apsSCRTopDirectory preferredChoices $machine.sdds]]} {
        global apsSCRTopDirectory
        APSSDDSListbox .preflist -parent $w -height 4 \
          -widthLimit 120 -trim 1 -label "Preferred/Reference Choices" \
          -fileName $apsSCRTopDirectory/preferredChoices/$machine.sdds \
          -labelMaker APSSCRMakePrefLBoxTextLine \
          -arrayName apsSCRMatchListPreferredArray$arrayName$machine \
          -page 0 -callback "APSListSCRMatchSetArrayCallback $machine apsSCRMatchListPreferredArray$arrayName$machine $callback 1 $arrayName" \
          -columnList {ChoiceName Suffix} \
          -contextHelp "Double-click to select a preferred file." -doneButton 0
    }

    $statusCallback "Pick a configuration to use"
    if {[llength $fileList] != 0} {
        APSDeleteTmpFileList -ID $tmpID
    }
    cd $oldDir
    set apsSCRSystem $old_apsSCRSystem
}

proc APSListSCRMatchSetArrayCallback {machine sourceArray callback mode arrayName index} {
    global $arrayName $sourceArray
    global apsSCRSnapDir 
    set ${arrayName}(FileNotFound) 1
    if $mode {
        # preferred file 
        set item [lindex [set $sourceArray\(ChoiceName\)] $index]
        if {![catch {APSSCRResolvePreferredFileChoice -system $machine -choice $item} file] && \
		[file exists [file join $apsSCRSnapDir $machine $file]]} {
            set file [file readlink [file join $apsSCRSnapDir $machine $file]]
	    if [catch {file readlink [file join $apsSCRSnapDir $machine [file tail $file]]} file1] {
		#do nothing, 
	    } else {
		set file $file1
	    }
            set filename0 [file tail $file]
            set ${arrayName}(IsPreferredFile) $mode
            set ${arrayName}(Filename) [file rootname $filename0]
            if {[file exists $apsSCRSnapDir/$machine/collapsed]} {
                set ${arrayName}(Description) \
                  [join [APSGetSDDSColumn -page 0 -column SnapshotDescription \
                           -fileName $apsSCRSnapDir/$machine/collapsed/c[file rootname $filename0]]]
            } else {
                set ${arrayName}(Description) \
                  [join [APSGetSDDSColumn -page 0 -column SnapshotDescription \
                           -fileName $apsSCRSnapDir/$machine/c[file rootname $filename0]]]
            }
            set ${arrayName}(FileNotFound) 0
            set ${arrayName}(Lattice) $item
        }
    } else {
        # normal file
        set ${arrayName}(IsPreferredFile) $mode
        set ${arrayName}(Filename) [lindex [set $sourceArray\(SnapshotFilename\)]  $index]
        set ${arrayName}(Description) [lindex [set $sourceArray\(SnapshotDescription\)] $index]
        set ${arrayName}(FileNotFound) 0
    }
    eval $callback ${arrayName} $machine
}

proc APSSCRMakePrefLBoxTextLine {args} {
    global apsSCRMakeLBoxTextLineMaxWidth
    set dataList {}
    set widthList {}
    APSStrictParseArguments {dataList widthList}
    set choice [lindex $dataList 0]
    set wc [lindex $widthList 0]
    set sform [format "%%%lds" $apsSCRMakeLBoxTextLineMaxWidth]
    return [format $sform $choice]
}

proc APSSCRMakeLBoxTextLine {args} {
    global apsSCRMakeLBoxTextLineMaxWidth
    set dataList {}
    set widthList {}
    APSStrictParseArguments {dataList widthList}
    set filename [lindex $dataList 0]
    set wf [lindex $widthList 0]
    set timestamp [lindex $dataList 1]
    set wt [lindex $widthList 1]
    set description [lindex $dataList 2]
    set wd [lindex $widthList 2]
    set rootname [file rootname $filename]
    set sform [format "%%%lds    %%%lds" $wt $wd] 
    set result [format $sform $timestamp $description]
    if [string length $result]>$apsSCRMakeLBoxTextLineMaxWidth {
        set apsSCRMakeLBoxTextLineMaxWidth [string length $result]
    }
    return $result
}

proc APSSCRFilterFileCallback {index} {
    global apsSCRFilterFileName apsSCRFilterFileDescription apsSCRFilterFileArray 
    global apsSCRFilterCategory apsSCRFilterBeamline apsSCRInvertFilterFile 
    global apsSCRPVNameFilter apsSCRPVSetpointFilter
    set apsSCRFilterFileName [lindex $apsSCRFilterFileArray(Filename) $index]
    set apsSCRFilterFileDescription [lindex $apsSCRFilterFileArray(Description) $index]
    set apsSCRPVNameFilter [lindex $apsSCRFilterFileArray(Wildcard) $index]
    set apsSCRInvertFilterFile 0
    set apsSCRPVSetpointFilter 0
    foreach elem [array names apsSCRFilterCategory] {
        set apsSCRFilterCategory($elem) 0
        foreach category [split [lindex $apsSCRFilterFileArray(CategoryList) $index] ", "] {
            if [string match $category $elem] {
                set apsSCRFilterCategory($elem) 1
            }
        }
    }
    foreach elem [array names apsSCRFilterBeamline] {
        set apsSCRFilterBeamline($elem) 0
        foreach beamline [split [lindex $apsSCRFilterFileArray(BeamlineList) $index] ", "] {
            if [string match $beamline $elem] {
                set apsSCRFilterBeamline($elem) 1
            }
        }
    }
}

proc APSSCRMakeLBoxTextFilterFile {args} {
    set dataList ""
    set widthList ""
    APSStrictParseArguments {dataList widthList}
    set description [lindex $dataList 1]
    set wd [lindex $widthList 1]
    if $wd<60 {set wd 60}
    set sform [format "%%%lds" $wd]
    return [format $sform $description]
}

proc APSSCRPVFilterWidget {widget args} {
    global apsSCRPVNameFilter apsSCRFilterFileDir apsSCRFilterFileName 
    global apsSCRFilterFileDescription apsSCRPVSetpointFilter
    global apsSCRInvertFilterFile apsSCRSuppressSingleBeamline

    set parent ""
    set fileName ""
    set rootname ""
    set snapDir ""
    APSStrictParseArguments {parent fileName rootname snapDir}

    set name [APSRemoveGzipExtension $fileName]

    APSFrame $widget -parent $parent -packOption "-side top -expand true -fill both"
    set w ${parent}${widget}.frame

    set categories $snapDir/categories/categ$name
    if ![file exists $categories] {
        set categories $snapDir/categ$name
    }
    if ![file exists $categories] {
        if catch {exec sddssort $snapDir/$fileName $categories -unique -column=Category} result] {
            return -code error "Error in generating category file (most probably you do not have write permission to $snapDir): $result"
        }
    }
    APSSDDSCheckButtons .list1 -parent $w -fileName $categories -column Category \
      -arrayName apsSCRFilterCategory -page 0 -limit 7 -duplicate 0 -modal 0 \
      -noOk 1 -noCancel 1 -buttonSize small

    set beamlines $snapDir/beamlines/beam$name
    if ![file exists $beamlines] {
        set beamlines $snapDir/beam$name
    }
    if ![file exists $beamlines] {
        if [catch {exec sddssort $snapDir/$fileName $beamlines -unique -column=Beamline} result] {
            return -code error "Error in generating beamline file (most probably you do not have write permission to $snapDir): $result"
        }
    }
    set showBeamlines 1
    if $apsSCRSuppressSingleBeamline {
        set nbeamlines [exec sdds2stream -rows=bare $beamlines]
        if $nbeamlines<=1 {
            set showBeamlines 0
        }
    }
    if $showBeamlines {
        APSSDDSCheckButtons .list2 -parent $w -fileName $beamlines -column Beamline \
          -arrayName apsSCRFilterBeamline -page 0 -limit 7 -duplicate 0 -modal 0 \
          -noOk 1 -noCancel 1 -buttonSize small
    } else {
        global apsSCRFilterBeamline
        set apsSCRFilterBeamline(DUMMY) 1
    }

    APSCheckButtonFrame .setpoints \
      -parent $w \
      -label "" \
      -buttonList {"Setpoints Only"} \
      -variableList "apsSCRPVSetpointFilter"

    if [winfo exists $w.pvname] {
        destroy $w.pvname
    }
    APSLabeledEntry .pvname -parent $w -textVariable apsSCRPVNameFilter -width 40  -label "PV name filter: " \
      -packOption "-side top" \
      -contextHelp "Enter a string to use in filtering process variable names prior to review/restore.\
 The character * matches zero or more arbitrary characters, while the character ? matches any single\
 character.  So S*A:Q1* would match all the A:Q1 quadrupole process variables for the SR.\n\n\
 Square brackets (\[ and \]) can be used to indicate sets of values.  For example, S\[1-4\]A:Q1*\
 would match all the A:Q1 quadrupole PVs in sectors 1 through 4, while S\[1-3\]9\[AB\]:Q1* would match*\
 A:Q1 and B:Q1 PVs in sectors 19, 29, and 39."

    bind $w.pvname.entry <Key> "set apsSCRInvertFilterFile 0"

    set filterFileList $apsSCRFilterFileDir/${rootname}-FilterFiles.sdds
    if [file exists $filterFileList] {
        # add a scroll widget with filter file selections
        APSFrame .ffframe -parent $w -label "Predefined filters" -packOption "-side top -expand true -fill both"
        APSSDDSListbox .fflist -parent $w.ffframe.frame -fileName $filterFileList -height 8 \
          -labelMaker APSSCRMakeLBoxTextFilterFile -arrayName apsSCRFilterFileArray \
          -page 0 -callback APSSCRFilterFileCallback \
          -columnList {Filename Description Wildcard BeamlineList CategoryList} \
          -contextHelp "Double-click to select a predefined filter." \
          -doneButton 0 -buttonSize small \
          -packOption "-side top -expand true -fill y"
        set apsSCRFilterFileDescription ""
        set apsSCRFilterFileName ""
        set apsSCRInvertFilterFile 0
        APSLabeledOutput .ffdescript -parent $w.ffframe.frame -label "Choice: "  \
          -textVariable apsSCRFilterFileDescription -width 40 \
          -contextHelp "Displays the choice of predefined filter.  If blank, no predefined filter is used."
        APSCheckButtonFrame .invert -parent $w.ffframe.frame -label "" \
          -buttonList {"Invert filter"} -variableList apsSCRInvertFilterFile \
          -orientation horizontal -relief flat -contextHelp \
          "Inverts the selection of PVs with the filter file, so that the items selected are all those that would  normally be rejected.  For some predefined filters (those using wildcards instead of a file), this feature is disabled." \
          -commandList {APSSCRInvertFilterFileCallback}

        APSButton .ffclear -parent $w.ffframe.frame -text CLEAR -size small \
          -command {set apsSCRFilterFileName ""; set apsSCRPVNameFilter *; \
                      set apsSCRFilterFileDescription "" ; set apsSCRInvertFilterFile 0} \
          -contextHelp "Clears the predefined filter choice, so that no predefined filter is used."
    }

}

proc APSSCRInvertFilterFileCallback {} {
    global apsSCRInvertFilterFile apsSCRFilterFileName
    if ![string length $apsSCRFilterFileName] {
        set apsSCRInvertFilterFile 0
        bell
    }
}

# make widget for date/time entry for start and end of
# region on interest
proc APSSCRDateTimeEntryWidget {widget args} {
    global apsSCRConfigStartYear apsSCRConfigStartMonth apsSCRConfigStartDay apsSCRConfigStartHour
    global apsSCRConfigEndYear apsSCRConfigEndMonth apsSCRConfigEndDay apsSCRConfigEndHour
    set apsSCRConfigStartYear ""
    set apsSCRConfigStartMonth ""
    set apsSCRConfigStartDay ""
    set apsSCRConfigStartHour 0
    set apsSCRConfigEndYear ""
    set apsSCRConfigEndMonth ""
    set apsSCRConfigEndDay ""
    set apsSCRConfigEndHour 24

    set parent .
    set command ""
    set relief flat
    APSStrictParseArguments {parent command relief}
    APSFrame $widget -parent $parent -label "" -relief $relief \
      -contextHelp "These widgets allow you to select the starting and ending date and time of interest."
    set w $parent$widget.frame

    APSDateTimeAdjEntry .date1 -parent $w \
      -label "Start  year, month, day, hour:" \
      -dayVariable apsSCRConfigStartDay -yearVariable apsSCRConfigStartYear \
      -monthVariable apsSCRConfigStartMonth -twoDigitYear 0 -buttonSize small \
      -hourVariable apsSCRConfigStartHour -command $command \
      -orientation horizontal -stackButtons 0
    APSDateTimeAdjEntry .date2 -parent $w \
      -label "End    year, month, day, hour:" \
      -dayVariable apsSCRConfigEndDay -yearVariable apsSCRConfigEndYear \
      -monthVariable apsSCRConfigEndMonth -twoDigitYear 0 -buttonSize small \
      -hourVariable apsSCRConfigEndHour -command $command -defaultHour 24 \
      -orientation horizontal -stackButtons 0
    APSIncrementDateVariables -offset -7 -unit day \
      -dayVariable apsSCRConfigStartDay -yearVariable apsSCRConfigStartYear \
      -monthVariable apsSCRConfigStartMonth 
    set apsSCRConfigStartHour 0
    set apsSCRConfigEndHour 24
}

proc APSSCRResolvePreferredFileChoice {args} {
    global apsSCRSystemList apsSCRRefChoiceDir
    set system ""
    set choice ""
    APSStrictParseArguments {system choice}
    if [string length $system]==0 {
        return -code error "APSSCRResolvePreferredFileChoice: No system named"
    }
    if [string length $choice]==0 {
        return -code error "APSSCRResolvePreferredFileChoice: No choice given"
    }
    if [lsearch -exact $apsSCRSystemList $system]==-1 {
        return -code error "APSSCRResolvePreferredFileChoice: invalid system $system"
    }
    set choiceFile $apsSCRRefChoiceDir/$system.sdds
    if ![file exists $choiceFile]  {
        set choiceList {"Operator Preferred" "System Manager Reference"}
        set suffixList {Preferred Reference}
    } else {
        if [catch {sdds open $choiceFile} fid] {
            return -code error "APSSCRResolvePreferredFileChoice: unable to open $choiceFile: $fid"
        }
        if [catch {sdds getColumn $fid ChoiceName} choiceList] {
            catch {sdds close $fid}
            return -code error "APSSCRResolvePreferredFileChoice: unable to read ChoiceName from $choiceFile: $choiceList"
        }
        if [catch {sdds getColumn $fid Suffix} suffixList] {
            catch {sdds close $fid}
            return -code error "APSSCRResolvePreferredFileChoice: unable to read Suffix from $choiceFile: $fileList"
        }
        catch {sdds close $fid}
    }
    set index [lsearch -exact $choiceList $choice] 
    if $index==-1 {
        return -code error "APSSCRResolvePreferredFileChoice: no choice $choice for $system"
    }
    return $system-[lindex $suffixList $index].gz
}

proc APSSCRGetPreferredChoiceList {args} {
    global apsSCRSystemList apsSCRRefChoiceDir
    set system ""
    APSStrictParseArguments {system}
    if [string length $system]==0 {
        return -code error "APSSCRGetPreferredChoiceList: No system named"
    }
    if [lsearch -exact $apsSCRSystemList $system]==-1 {
        return -code error "APSSCRGetPreferredChoiceList: invalid system $system"
    }
    set choiceFile $apsSCRRefChoiceDir/$system.sdds
    if ![file exists $choiceFile]  {
        set choiceList {"Operator Preferred" "System Manager Reference"}
    } else {
        if [catch {sdds open $choiceFile} fid] {
            return -code error "APSSCRGetPreferredChoiceList: unable to open $choiceFile: $fid"
        }
        if [catch {sdds getColumn $fid ChoiceName} choiceList] {
            catch {sdds close $fid}
            return -code error "APSSCRGetPreferredChoiceList: unable to read ChoiceName from $choiceFile: $choiceList"
        }
        catch {sdds close $fid}
    }
    return $choiceList
}

proc APSSCRGetPreferredDataLists {args} {
    global apsSCRSystemList apsSCRRefChoiceDir apsSCRAccelManagerAccount
    set system ""
    APSStrictParseArguments {system}
    if [string length $system]==0 {
        return -code error "APSSCRGetPreferredDataLists: No system named"
    }
    if [lsearch -exact $apsSCRSystemList $system]==-1 {
        return -code error "APSSCRGetPreferredDataLists: invalid system $system"
    }
    set choiceFile $apsSCRRefChoiceDir/$system.sdds
    if ![file exists $choiceFile]  {
        # default values if file doesn't exist.
        set choiceList {"System Manager Reference" "Operator Preferred"}
        set suffixList {Reference Preferred}
        set userList [list $apsSCRAccelManagerAccount($system) $apsSCRAccelManagerAccount($system)]
    } else {
        if [catch {sdds open $choiceFile} fid] {
            return -code error "APSSCRGetPreferredDataLists: unable to open $choiceFile: $fid"
        }
        if [catch {sdds getColumn $fid ChoiceName} choiceList] {
            catch {sdds close $fid}
            return -code error "APSSCRGetPreferredDataLists: unable to read ChoiceName from $choiceFile: $choiceList"
        }
        if [catch {sdds getColumn $fid Suffix} suffixList] {
            catch {sdds close $fid}
            return -code error "APSSCRGetPreferredDataLists: unable to read Suffix from $choiceFile: $suffixList"
        }
        if [catch {sdds getColumn $fid PrivilegedUsers} userList] {
            catch {sdds close $fid}
            return -code error "APSSCRGetPreferredDataLists: unable to read PrivilegedUsers from $choiceFile: $suffixList"
        }
        catch {sdds close $fid}
    }
    return [list $choiceList $suffixList $userList]
}

proc APSSCRInstallPreferredFile {args} {
    global apsSCRSystemList apsSCRRefChoiceDir apsSCRSnapDir
    set system ""
    set choice ""
    set filename ""
    APSStrictParseArguments {system choice filename}
    #if {$system=="SR" && [string compare $choice "User beam operator preferred"]==0} {
#	set link [file readlink /home/helios/oagData/SCR/snapshots/SR/SR-UserBeamPreferred.gz]
	#if {[file tail $link]=="SR-UserBeamPreferredNoP0Feedback.gz"} {
	 #   set choice "User beam operator preferred without P0 feedback"
	#} elseif {[file tail $link]=="SR-UserBeamPreferredWithP0Feedback.gz"} {
	#    set choice "User beam operator preferred with P0 feedback"
#	} else {
	#    return -code error "SR UBOP was linked to invalid link - $link!"
#	}
 #   }
    if [string length $system]==0 {
        return -code error "APSSCRInstallPreferredFile: No system named"
    }
    if [string length $choice]==0 {
        return -code error "APSSCRInstallPreferredFile: No choice given"
    }
    if [string length $filename]==0 {
        return -code error "APSSCRInstallPreferredFile: No filename given"
    }
    if [lsearch -exact $apsSCRSystemList $system]==-1 {
        return -code error "APSSCRInstallPreferredFile: invalid system $system"
    }
    if ![file exists [file join $apsSCRSnapDir $system $filename]] {
        return -code error "APSSCRInstallPreferredFile: $filename not found for system $system"
    }
    if [catch {APSGetSDDSParameter -parameter SnapshotDescription -fileName $apsSCRSnapDir/$system/$filename \
                 -page 1} Description] {
        return -code error "APSSCRInstallPreferredFile: problem reading Description: $Description"
    }
    if [string first "Routine save" $Description]!=-1 {
        return -code error "APSSCRInstallPreferredFile: can't make routine save into preferred file."
    }
    if [catch {APSSCRGetPreferredDataLists -system $system} dataLists] {
        return -code error "APSSCRInstallPreferredFile: $dataLists"
    }
# change this to use sdds load.
    set choiceList [lindex $dataLists 0]
    set suffixList [lindex $dataLists 1]
    set usersList  [lindex $dataLists 2]
    set index [lsearch -exact $choiceList $choice] 
    if $index==-1 {
        return -code error "APSSCRInstallPreferredFile: no choice $choice for $system"
    }
    set userList [split [lindex $usersList $index]]
    catch {exec whoami} userName
    if [lsearch -exact $userList $userName]==-1 {
        return -code error "APSSCRInstallPreferredFile: $userName doesn't have privileges for this operation.  The following users have the required privileges: $userList"
    }
    set linkName $apsSCRSnapDir/$system/$system-[lindex $suffixList $index].gz
    catch {file delete -force $linkName}
    if {[file exists $linkName] && [catch {file delete -force $linkName} result]} {
        return -code error "APSSCRInstallPreferredFile: unable to remove link $linkName: $result"
    }
    if [catch {exec ln -s $apsSCRSnapDir/$system/$filename $linkName} result] {
        return -code error "APSSCRInstallPreferredFile: unable to install preferred file: $result"
    }
    if [catch {APSSCRLogAction -file $filename -action "installed-as-$choice"} result] {
        return -code error "APSSCRInstallPreferredFile: $result"
    }
}

proc APSSCRAlterSnapshot {args} {
    set sourceSnapshot ""
    set replacementData ""
    set description ""
    set machine ""
    APSStrictParseArguments {sourceSnapshot replacementData description machine}

    if {![string length $sourceSnapshot] || ![file exists $sourceSnapshot]} {
        return -code error "APSSCRAlterSnapshot: invalid/nonexistent sourceSnapshot named."
    }
    if {![string length $replacementData] || ![file exists $replacementData]} {
        return -code error "APSSCRAlterSnapshot: invalid/nonexistent replacement data file named."
    }

    # get names of data columns from source snapshot and replacement data file
    # to ensure that nothing is missing from the latter
    if [catch {APSGetSDDSNames -fileName $sourceSnapshot -class column} snapshotColumns] {
        return -code error "APSSCRAlterSnapshot: $snapshotColumns"
    }
    if [catch {APSGetSDDSNames -fileName $replacementData -class column} replacementColumns] {
        return -code error "APSSCRAlterSnapshot: $replacementColumns"
    }
    
    set missingList ""
    set ignoreList [list CAError IndirectName BackupMsg RestoreMsg]
    foreach column $snapshotColumns {
        if [lsearch -exact $ignoreList $column]!=-1 continue
        if [lsearch -exact $replacementColumns $column]==-1 {
            lappend missingList $column
        }
    }
    if [llength $missingList]!=0 {
       # return -code error "APSSCRAlterSnapshot: $replacementData is missing the following columns: [join $missingList ,]"
        set answer  [APSMultipleChoice .info -name "Columns do not match" \
                      -question "APSSCRAlterSnapshot: $replacementData is missing the following columns: [join $missingList ,]\nDo you wish to continue or abort this procedure?" \
                      -labelList {Continue Abort} \
                      -returnList {Continue Abort} ]
        if {$answer=="Abort"} {
            return -code error "APSSCRAlterSnapshot: $replacementData is missing the following columns: [join $missingList ,]"
        }
    }

    set dataList [APSSCRMakeSnapshotFilename -machine $machine]
    set newFilename [lindex $dataList 0]
    set timeList [lrange $dataList 1 end]
    set time0 [format %.0lf [lindex $timeList 8]]
    set tmpRoot /tmp/[APSTmpString]
    set tmpID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $tmpID -fileList [list $tmpRoot.keep $tmpRoot.new $tmpRoot.repl]
    if [catch {exec sddsconvert $replacementData $tmpRoot.repl \
                 -retain=col,[join $snapshotColumns ,]
        exec sddsselect $sourceSnapshot $tmpRoot.repl $tmpRoot.keep \
                 -match=ControlName -invert -reuse=rows
        exec sddscombine $tmpRoot.keep $tmpRoot.repl -pipe=out -merge \
                 -delete=column,CAError \
                 | sddsprocess -pipe=in $tmpRoot.new \
                 "-reprint=param,SnapshotDescription,[APSMakeSafeQualifierString $description]" \
                 "-redefine=param,Time,$time0" \
                 "-reprint=param,SnapshotFilename,$newFilename"
        file delete $tmpRoot.keep } result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSSCRAlterSnapshot: $result"
    }

    set snaproot  [file tail [file rootname $sourceSnapshot]]
    set snapexten [file extension $sourceSnapshot]
    set snapdir   [file dirname $sourceSnapshot]/
    if [string compare $snapdir ./]==0 {
        set snapdir ""
    }
    set newroot   [file tail [file rootname $newFilename]]
    set newexten  .gz
    set waveformFile ${snapdir}${snaproot}.waveform.gz
    if [catch {exec gzip -c $tmpRoot.new > $snapdir$newroot.gz
        if {[file exists ${snapdir}/collapsed]} {
            exec sddscollapse $snapdir$newroot.gz ${snapdir}/collapsed/c$newroot
        } else {
            exec sddscollapse $snapdir$newroot.gz ${snapdir}c$newroot
        }
        if {[file exists ${snapdir}/categories/categ$snaproot]} {
            exec cp ${snapdir}/categories/categ$snaproot ${snapdir}/categories/categ$newroot 
        } else {
            exec cp ${snapdir}categ$snaproot ${snapdir}categ$newroot 
        }
        if {[file exists ${snapdir}/beamlines/beam$snaproot]} {
            exec cp ${snapdir}/beamlines/beam$snaproot ${snapdir}/beamlines/beam$newroot
        } else {
            exec cp ${snapdir}beam$snaproot ${snapdir}beam$newroot
        }
    } result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSSCRAlterSnapshot: $result"
    }
    if [file exist $waveformFile] {
        if [catch {exec cp $waveformFile $snapdir$newroot.waveform.gz} result] {
            return -code error "APSSCRAlterSnapshot2: $result"
        }
    }
    APSDeleteTmpFileList -ID $tmpID
    return $newroot.gz
}

proc APSAlterSCRRequestFile {args} {
    set input ""
    set output ""
    set add ""
    set remove ""
    set rename ""
    set usage "arguments: -input <filename> -output <filename> -add <filename> -remove <filename> -rename <filename>"
    if {[APSStrictParseArguments {input output add remove rename}] || \
          ![string length $input] || ![string length $output] || \
          (![string length $add] && ![string length $remove] \
             && ![string length $rename])} {
        return -code error "APSAlterSCRRequestFile: $usage"
    }
    if ![file exists $input] {
        return -code error "APSAlterSCRRequestFile: Not found: $input"
    }
    if [file exists $output] {
        return -code error "APSAlterSCRRequestFile: Already exists: $output"
    }
    set tmpInput /tmp/[APSTmpString]
    set tmpID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $tmpID -fileList $tmpInput
    if [catch {exec cp $input $tmpInput} result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSAlterSCRRequestFile: $result"
    }
    if [string length $rename] {
        set tmpOutput /tmp/[APSTmpString]
        APSAddToTmpFileList -ID $tmpID -fileList $tmpOutput
        if [catch {APSRenameInSCRRequestFile \
                     -input $tmpInput -output $tmpOutput \
                     -rename $rename} result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSAlterSCRRequestFile: $result"
        }
        set tmpInput $tmpOutput
    }
    if [string length $remove] {
        set tmpOutput /tmp/[APSTmpString]
        APSAddToTmpFileList -ID $tmpID -fileList $tmpOutput
        if [catch {APSRemoveFromSCRRequestFile \
                     -input $tmpInput -output $tmpOutput \
                     -remove $remove} result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSAlterSCRRequestFile: $result"
        }
        set tmpInput $tmpOutput
    }
    if [string length $add] {
        set tmpOutput /tmp/[APSTmpString]
        APSAddToTmpFileList -ID $tmpID -fileList $tmpOutput
        if [catch {APSAddToSCRRequestFile -input $tmpInput -output $tmpOutput \
                     -add $add} result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSAlterSCRRequestFile: $result"
        }
        set tmpInput $tmpOutput
    }
    if [file exists $tmpOutput] {
        if [catch {exec cp $tmpOutput $output} result] {
            APSDeleteTmpFileList -ID $tmpID
            return -code error "APSAlterSCRRequestFile: $result"
        }
    } else {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSAlterSCRRequestFile: $tmpOutput not found"
    }
}

proc APSAddToSCRRequestFile {args} {
    # Adds data from file $add to file $input and puts result in $output.
    # If ControlNames in $add match any in $input, then those in $input
    # are deleted.

    set input ""
    set output ""
    set add ""
    APSStrictParseArguments {input output add} 

    if {![string length $input] || ![string length $output] || \
          ![string length $add]} {
        return -code error "APSAddToSCRRequestFile: arguments:  -input <filename> -output <filename> -add <filename>"
    }
    if ![file exists $input] {
        return -code error "APSAddToSCRRequestFile: not found: $input"
    }
    if [file exists $output] {
        return -code error "APSAddToSCRRequestFile: already exists: $output"
    }
    if ![file exists $add] {
        return -code error "APSAddToSCRRequestFile: not found: $add"
    }
    
    if [catch {APSGetSDDSNames -fileName $input -class column} inputColumns] {
        return -code error "APSAddToSCRRequestFile: $inputColumns"
    }
    if [catch {APSGetSDDSNames -fileName $add -class column} addColumns] {
        return -code error "APSAddToSCRRequestFile: $addColumns"
    }
    foreach item $inputColumns {
        if [lsearch -exact $addColumns $item]==-1 {
            return -code error "APSAddToSCRRequestFile: $item not in $add but in $input"
        }
    }
    set tmpRoot /tmp/[APSTmpString]
    set tmpID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $tmpID -fileList \
      [list $tmpRoot.add $tmpRoot.keep]
    if [catch {exec sddsconvert $add $tmpRoot.add \
                 -retain=column,[join $inputColumns ,]
        exec sddsselect $input $tmpRoot.add $tmpRoot.keep \
                 -match=ControlName -invert -reuse=page,row
        exec sddscombine $tmpRoot.add $tmpRoot.keep -merge $output} result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSAddToSCRRequestFile: $result"
    }
    catch {eval file delete $tmpRoot.add $tmpRoot.keep}
    if ![file exists $output] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSAddToSCRRequestFile: not found after processing!"
    }
    APSDeleteTmpFileList -ID $tmpID
}

proc APSRemoveFromSCRRequestFile {args} {
    set input ""
    set output ""
    set remove ""
    set usage "arguments: -input <filename> -output <filename> <filename> -remove <filename>"
    if {[APSStrictParseArguments {input output remove}] || \
          ![string length $input] || ![string length $output] || \
          ![string length $remove]} {
        return -code error "APSRemoveFromSCRRequestFile: $usage"
    }
    if ![file exists $input] {
        return -code error "APSRemoveFromSCRRequestFile: Not found: $input"
    }
    if [file exists $output] {
        return -code error "APSRemoveFromSCRRequestFile: Already exists: $output"
    }
    if ![file exists $remove] {
        return -code error "APSRemoveFromSCRRequestFile: not found: $add"
    }
    if [catch {exec sddsselect $input $remove $output -match=ControlName -invert \
                 -reuse=page,row} result] {
        return -code error "APSRemoveFromSCRRequestFile: $result"
    }
}

proc APSRenameInSCRRequestFile {args} {
    set input ""
    set output ""
    set rename ""
    set usage "arguments: -input <filename> -output <filename> <filename> -rename <filename>"
    if {[APSStrictParseArguments {input output rename}] || \
          ![string length $input] || ![string length $output] || \
          ![string length $rename]} {
        return -code error "APSRenameFromSCRRequestFile: $usage"
    }
    if ![file exists $input] {
        return -code error "APSRenameFromSCRRequestFile: Not found: $input"
    }
    if [file exists $output] {
        return -code error "APSRenameFromSCRRequestFile: Already exists: $output"
    }
    if ![file exists $rename] {
        return -code error "APSRenameFromSCRRequestFile: not found: $add"
    }
    set tmpRoot /tmp/[APSTmpString]
    set tmpID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $tmpID -fileList \
      [list $tmpRoot.add $tmpRoot.renamed]
    if [catch {exec sddsselect $input $rename $tmpRoot.keep -reuse=page,row \
                 -match=ControlName=OldControlName -invert} result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSRenameFromSCRRequestFile: $result"
    }
    if [catch {exec sddsxref -nowarning $input $rename -pipe=out -reuse=page,row \
                 -match=ControlName=OldControlName -take=NewControlName \
                 | sddsconvert -pipe=in $tmpRoot.renamed \
                 -delete=column,ControlName \
                 -rename=column,NewControlName=ControlName} result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSRenameFromSCRRequestFile: $result"
    }
    if [catch {exec sddscombine $tmpRoot.keep $tmpRoot.renamed -merge \
                 $output -overwrite} result] {
        APSDeleteTmpFileList -ID $tmpID
        return -code error "APSRenameFromSCRRequestFile: $result"
    }

}

# This procedure takes a request file and makes another SDDS file
# containing one row for each unique value of a specified column.
# Used for making category and beamline lists after creating a
# new request file.

proc APSMakeSCRCategoryFiles {args} {
    set input ""
    APSStrictParseArguments {input} 
    if {![string length $input] || ![file exists $input]} {
        return -code error "APSMakeSCRCategoryFiles: input file not given or nonexistent: $input"
    }
    set mtime0 [file mtime $input]
    set extensionList {categories beamlines}
    set columnList {Category Beamline}
    set index -1 
    foreach column $columnList {
        incr index 
        set output $input.[lindex $extensionList $index]
        if {![file exists $output] || \
              [file mtime $output]<=$mtime0} {
            if [catch {exec sddsbreak -rowlimit=100 $input -pipe=out \
                         | sddssort -pipe -column=$column -unique \
                         | sddscombine -merge -pipe \
                         | sddssort -pipe=in -column=$column -unique $output} result] {
                return -code error "APSMakeSCRCategoryFiles: $result"
            }
        }
    }
}

proc APSScaleSnapshot {args} {
    set input ""
    set output ""
    set factor 1
    if [APSStrictParseArguments {input output factor}] {
        return -code error "APSScaleSnapshot: unknown options given"
    }

    if ![string length $input] {
        return -code error "APSScaleSnapshot: provide input file name"
    }
    if ![string length $output] {
        return -code error "APSScaleSnapshot: provide output file name"
    }
    if ![file exists $input] {
        return -code error "APSScaleSnapshot: $input not found"
    }
    if [catch {APSGetSDDSNames -fileName $input -class column} inputColumnList] {
        return -code error "APSScaleSnapshot: $inputColumnList"
    }
    foreach item {ControlName ValueString} {
        if [lsearch -exact $inputColumnList $item]==-1 {
            return -code error "APSScaleSnapshot: $item is missing from $input"
        }
    }
    if [lsearch -exact $inputColumnList IsNumerical]!=-1 {
        lappend selectOption -match=column,IsNumerical=+y
    }
    lappend selectOption -numberTest=column,ValueString,strict

    set tmpRoot /tmp/[APSTmpString]
    set ID [APSUniqueName tmpID]
    APSAddToTmpFileList -ID $ID -fileList [list $tmpRoot.1 $tmpRoot.2 ]
    if [catch {eval exec sddsconvert $input -pipe=out \
                 -delete=column,Value,ValueString2 \
                 | sddsprocess -pipe $selectOption \
                 -scan=column,Value,ValueString,%lf \
                 {"-redefine=column,Value,Value $factor *"} \
                 -print=column,ValueString2,%.15e,Value \
                 | sddsconvert -pipe=in $tmpRoot.1 \
                 -delete=column,Value,ValueString \
                 -rename=column,ValueString2=ValueString 
        exec sddsselect $input $tmpRoot.1 -match=ControlName -invert $tmpRoot.2 
        exec sddscombine $tmpRoot.1 $tmpRoot.2 $output -merge -overWrite } result] {
        APSDeleteTmpFileList -ID $ID
        return -code error "APSScaleSnapshot: $result"
    }
    APSDeleteTmpFileList -ID $ID
}

proc CompareRequestOrMonitorFiles {args} {
    set lastFile ""
    set newFile ""
    set root ""
    set type req
    set install 0
    APSParseArguments {lastFile newFile root type install}
    
    if {![file exist $newFile] || ![file exist $lastFile]} {
        return
    }
    if $install {
        switch $type {
            req {
                set pvsAddedFile $root.added
                set pvsRemovedFile $root.removed
            }
            mon {
                set pvsAddedFile PVsAdded
                set pvsRemovedFile PVsRemoved
            }
            default {
                return -code error "Invalid monitor type, should be req or mon!"
            }
        }
    } else {
        set pvsAddedFile /tmp/[APSTmpString].$root.added
        set pvsRemovedFile /tmp/[APSTmpString].$root.removed
    }
    
    if [catch {exec sddsselect $newFile $lastFile $pvsAddedFile \
                   -match=ControlName -invert -nowarnings
        exec sddsselect $lastFile $newFile $pvsRemovedFile \
                   -match=ControlName -invert -nowarnings } result] {
        return -code error $result
    }
    
    set rowsAdded [exec sdds2stream -rows=bar $pvsAddedFile]
    set rowsRemoved [exec sdds2stream -rows=bar $pvsRemovedFile]
    if {$rowsAdded || $rowsRemoved} {
        set message "New file $newFile differs from last file $lastFile.\n"
        append message "New  file: [exec sdds2stream -rows $newFile]\n"
        append message "Last file: [exec sdds2stream -rows $lastFile]\n"
        append message "PVs added: $rowsAdded rows.\n"
        append message "PVs removed: $rowsRemoved rows.\n"
        if $rowsAdded {
            append message "Following PVs were added...\n"
            append message "[exec sdds2stream -col=ControlName $pvsAddedFile]\n"
        }
        if $rowsRemoved {
            append message "\nFollowing PVs were removed...\n"
            append message "[exec sdds2stream -col=ControlName $pvsRemovedFile]\n"
        }
        return -code error $message
    }
}

proc APSSCRRampSRMagnets {args} {
    set doQuads 0
    set doSextoples 1
    set SCRFile ""
    set machine SR
    APSParseArguments {doQuads doSextoples SCRFile machine}
    set matchOpt ""
    
    set dir /home/helios/oagData/SCR/snapshots/$machine
    if {!$doQuads && !$doSextoples} {
        return -code error "APSSRRampMagnets(1): At least one of the quads or sextoples has to be selected for ramp SR magnets!"
    }
    if $doQuads {
        set matchOpt -match=column,ControlName=S*:Q*:CurrentAO
    }
    if $doSextoples {
        if [string length $matchOpt] {
            append matchOpt ,ControlName=S*:S?:CurrentAO,|
        } else {
            set matchOpt -match=column,ControlName=S*:S?:CurrentAO
        }
    }
    append matchOpt " -match=column,Beamline=SR -match=column,Category=MainPS -match=column,IsProtected=+n  -match=column,ControlType=pv"
    set tmpfile /tmp/[APSTmpString]
    if [catch {eval exec sddsprocess $dir/$SCRFile $tmpfile $matchOpt \
             \"-match=col,ControlName=,!\" \"-match=col,ValueString=,!\" } result] {
        return -code error "APSSRRampMagnets(2): $result"
    }
    
    set restoreTimeStamp "[clock format [clock seconds]]"
    if [catch {APSSCRLogAction -file $SCRFile -action restore-start} result] {
        return -code error "APSSRRampMagnets(2a): $result"
    }
    
    if [catch {APSRampToSnapshot -initDialog 1 \
                 -logFile $tmpfile.log -fileName $tmpfile} result] {
        return -code error "APSSRRampMagnets(3 - APSRampToSnapshot): $result"
    } 
    if [catch {APSSCRLogAction -file $dir/$SCRFile -action restore-end} result] {
        return -code error "APSSRRampMagnets(3a - APSSCRLogAction): $result"
    }
    #track restored file
    if [catch {APSSCRTrackRestoreFile -sourceFile $SCRFile \
                 -machine $machine -restoreFile $tmpfile \
                 -timeStamp $restoreTimeStamp} result] {
        return -code error "APSSRRampMagnets(4 - APSSCRTrackRestoredFile): $result"
    }
}

proc APSSCRTrackRestoreFile {args} {
    set sourceFile ""
    set machine ""
    set restoreFile ""
    set timeStamp ""
    APSParseArguments {sourceFile machine restoreFile timeStamp}
    global env 

    set restoreDir /home/helios/oagData/SCR/restoreTracking
    if {![string length $restoreFile] || ![string length $sourceFile] } {
        return
    }
    set suffix [lindex [APSSCRMakeSnapshotFilename -machine $machine] 0]
    regexp "${machine}(.*)" $suffix a suffix
    if ![file exist $restoreDir/$machine] {
        exec mkdir $restoreDir/$machine
        #catch {exec setfacl -m mask:rwx $restoreDir/$machine}
    }
    if [regexp {(.*).gz} $sourceFile a b] {
        set prefix $b
    } else {
        set prefix $sourceFile
    }
    set filename ${prefix}_${suffix}
    
    if [catch {exec sddsprocess $restoreFile \
                 "-reprint=par,System,$machine" \
                 "-reprint=par,SourceFile,$sourceFile" \
                 "-reprint=par,User,$env(USER)" \
                 "-reprint=par,TimeStamp,$timeStamp" -pipe=out \
                 | gzip -c > $restoreDir/${machine}/$filename.gz } result] {
        return -code error "Error gzipping file: $result"
    }
}


# Adds an SCR dialog to a window.  Suitable for use with PEM init dialogs

proc APSAddSCRDialog {widget args} {
    set parent ""
    set label ""
    set arrayName ""
    set daysPast 7
    set system LINAC
    set defaultFile ""
    set description ""
    set PreferredOnly 0
    set searchDescription *
    APSStrictParseArguments {parent label arrayName daysPast system defaultFile description PreferredOnly searchDescription}
    if {[llength $label] == 0} {
        set label "Choose $system SCR file"
    }
    APSFrame $widget -parent $parent -label $label -packOption "-expand 1 -fill both"
    set w $parent$widget.frame
    global $arrayName
    global apsSCRConfigStartYear apsSCRConfigStartMonth apsSCRConfigStartDay apsSCRConfigDescriptionSearchString
    global apsSCRConfigEndYear apsSCRConfigEndMonth apsSCRConfigEndDay apsSCRSystem
    set apsSCRConfigDescriptionSearchString "$searchDescription"
    set apsSCRSystem $system
    if !$PreferredOnly {
        APSSCRDateTimeEntryWidget .dtew -parent $w 
    }
    APSSCRDefineVariables
    APSDateBreakDown -dayVariable apsSCRConfigStartDay \
      -yearVariable apsSCRConfigStartYear -monthVariable apsSCRConfigStartMonth \
      -twoDigitYear 0 -leadingZeros 0
    APSDateBreakDown -dayVariable apsSCRConfigEndDay \
      -yearVariable apsSCRConfigEndYear -monthVariable apsSCRConfigEndMonth \
      -twoDigitYear 0 -leadingZeros 0
    if $daysPast {
        APSIncrementDateVariables -offset [expr -1*abs($daysPast)] -unit day \
          -dayVariable apsSCRConfigStartDay -yearVariable apsSCRConfigStartYear \
          -monthVariable apsSCRConfigStartMonth 
    }
    
    APSFrame .choice -parent $w -label "Snapshot choice (${system})"
    set w1 $w.choice.frame
    set ${arrayName}(ShortFilename) $defaultFile
    set ${arrayName}(Description) $description
    APSLabeledOutput .filename -parent $w1 -label "Filename" \
      -textVariable ${arrayName}(ShortFilename) -width 100
    APSLabeledOutput .description -parent $w1 -label "Description" \
      -textVariable ${arrayName}(Description) -width 100
    APSLabeledEntry .descript -parent $w1 -label "Description search string: " \
      -textVariable apsSCRConfigDescriptionSearchString  -packOption "-side top" -width 40 \
      -contextHelp \
      "Enter a string to use in searching for files by matching the description given by the operator who saved the snapshot." \
      -packOption "-side left -anchor n"
    
    if !$PreferredOnly {
        APSButton .refresh -parent $w1 -text Refresh \
          -command \
          "APSListSCRMatchSetArray -machine $system -height 4 \
      -startYear \$apsSCRConfigStartYear -startMonth \$apsSCRConfigStartMonth \
      -startDay \$apsSCRConfigStartDay \
      -endYear \$apsSCRConfigEndYear -endMonth \$apsSCRConfigEndMonth \
      -endDay \$apsSCRConfigEndDay \
      -descriptionFragment \$apsSCRConfigDescriptionSearchString -parent $w \
      -statusCallback APSNoOp -callback APSAddSCRDialogCallback \
      -arrayName $arrayName -routine 0 -PreferredOnly $PreferredOnly -listOrder decreasing" 
       
        APSButton .clear -parent $w1 -text Clear \
          -command "set ${arrayName}(ShortFilename) {}; set ${arrayName}(Description) {}; set ${arrayName}(Filename) {};set apsSCRConfigDescriptionSearchString *"
    }
    
    APSListSCRMatchSetArray -machine $system -height 3 \
      -startYear $apsSCRConfigStartYear -startMonth $apsSCRConfigStartMonth \
      -startDay $apsSCRConfigStartDay \
      -endYear $apsSCRConfigEndYear -endMonth $apsSCRConfigEndMonth \
      -endDay $apsSCRConfigEndDay \
      -descriptionFragment $apsSCRConfigDescriptionSearchString -parent $w -statusCallback "APSNoOp" \
      -callback APSAddSCRDialogCallback -arrayName $arrayName \
      -PreferredOnly $PreferredOnly \
      -routine 0 -listOrder decreasing

    set ${arrayName}(ShortFilename) $defaultFile
    set ${arrayName}(PreferredOnly) $PreferredOnly
    return
}

proc APSAddSCRDialogCallback {arrayName machine} {
    global $arrayName apsSCRSnapDir status 
    if [set ${arrayName}(FileNotFound)] {
        set status "File not found!"
        update
        return
    }
    set name [set ${arrayName}(Filename)]
    set descrip [set ${arrayName}(Description)]
    set snapDir $apsSCRSnapDir/$machine
    if ![file exists $snapDir/$name] {
        if [file exists $snapDir/${name}.gz] {
            set name ${name}.gz
        } else {
            set status "File not found!"
            update
            return
        }
    }
    set ${arrayName}(ShortFilename) $name
    set ${arrayName}(Filename) $snapDir/$name
}

proc APSMpGenericPSArrayQuery {args} {
    set arrayName ""
    set operation ""
    set invert 0
    APSStrictParseArguments {arrayName operation invert}
    global $arrayName

    set chosenList ""
    # <operation>,DeviceList is the list of devices in a group
    # supporting an operation
    # <operation>,DeviceVariableList is the list of Tcl variables
    # associated with checkbuttons for users to select the operation for
    # a device

    foreach device [set ${arrayName}($operation,DeviceList)] \
      choiceVar [set ${arrayName}($operation,DeviceVariableList)] {
          if [set $choiceVar]!=$invert {
              lappend chosenList $device
          }
      }
    return $chosenList
}
