#
# $Log: not supported by cvs2svn $
# Revision 1.6  2000/06/27 16:20:03  soliday
# Added catch statements around all the grab commands.
#
# Revision 1.5  1996/10/07 23:29:11  borland
# Added -buttonSize option.
#
# Revision 1.4  1996/06/03  21:22:18  borland
# Added -noCancel option.
#
# Revision 1.3  1996/03/29  17:39:53  borland
# Now removes old array and sets array values to 0 to ensure that all array
# slots exist.
#
# Revision 1.2  1996/02/10  00:57:54  borland
# Added -noOk option.  Now uses APSStrictParseArguments.
#
# Revision 1.1  1996/01/16  21:38:31  saunders
# Unofficial routines from ~borland/tcl/rel added. These should
# ultimately be removed from use or modified to comply with
# current conventions.
#
#


set apsCheckButtonsID 0
proc APSSDDSCheckButtons {widget args} {
    global apsCheckButtonsID
    incr apsCheckButtonsID
    global apsCheckButtonstkWaitVar$apsCheckButtonsID

    set callback ""
    set modal 0
    set page 0
    set arrayName ""
    set column ""
    set fileName ""
    set parent ""
    set name "Check Button Dialog"
    set limit 0
    set widthLimit 0
    set duplicate 0
    set noOk 0
    set noCancel 0
    set buttonSize medium
    APSStrictParseArguments {callback modal page arrayName column fileName parent name \
                               limit widthLimit duplicate noOk noCancel buttonSize}
    if {$limit==0 && $widthLimit==0} {
        set widthLimit 100
    }

    if {[string length $fileName]==0 || ![file exists $fileName] ||
        [string length $column]==0} { 
        return 0 
    }
    set data [APSGetSDDSColumn -fileName $fileName -column $column -page $page]
    if {[llength $data]==0} {
        return 0
    } elseif {$duplicate == 0} {
        set dataindex 0
        set data [lsort $data]
        set nextdata [lindex $data [expr {$dataindex + 1}]]
        set newdatalist ""

        foreach elem $data {
	    if {($nextdata != $elem)} {
		lappend newdatalist [lindex $data $dataindex]
	    }
	    incr dataindex
	    set nextdata [lindex $data [expr {$dataindex + 1}]]
        }
        unset data
        set data $newdatalist
    }
    global $arrayName
    if {[array exists $arrayName]} {unset $arrayName}

    APSDialogBox $widget -parent $parent -name $name -buttonSize small
    set w $parent$widget

    APSDialogBoxAddButton .setall -parent $w -text "SET ALL" \
      -command "APSSetAllArrayEntries $arrayName 1" \
      -contextHelp "Set all checkbuttons." \
      -size small
    APSDialogBoxAddButton .clear -parent $w -text "CLEAR" \
      -command "APSSetAllArrayEntries $arrayName 0" \
      -contextHelp "Clear all checkbuttons." \
      -size small

    set i 0
    set row 0
    set width 0
    set first 1
    foreach elem $data {
        set length [string length $elem]
        set width [expr {$width+$length}]
        if {$first || ($limit!=0 && $i%$limit==0) || ($widthLimit!=0 && $width>$widthLimit)} {
            set first 0
            incr row
            frame $w.userFrame.row$row -bd 2
            pack $w.userFrame.row$row -side top
            set width $length
        }
        set vname [join [concat $arrayName ( $elem )] ""]
        set $vname 0
        checkbutton $w.userFrame.row$row.cb$i -variable $vname -text $elem
        set $vname 0
        pack $w.userFrame.row$row.cb$i -side left
        incr i
    }
    if {[string length $callback]==0} {
        $w.buttonRow.ok.button configure \
          -command "destroy $w; \
                        set apsCheckButtonstkWaitVar$apsCheckButtonsID OK"
        $w.buttonRow.cancel.button configure \
          -command "APSSetAllArrayEntries $arrayName 0; \
                        destroy $w; \
                        set apsCheckButtonstkWaitVar$apsCheckButtonsID CANCEL"  
    } else {
        $w.buttonRow.ok.button configure \
          -command "destroy $w; \
                        $callback $arrayName OK; \
                        set apsCheckButtonstkWaitVar$apsCheckButtonsID OK" 
        $w.buttonRow.cancel.button configure \
          -command "APSSetAllArrayEntries $arrayName 0; \
                        destroy $w; \
                        $callback $arrayName CANCEL; \
                        set apsCheckButtonstkWaitVar$apsCheckButtonsID CANCEL"  
    }
    APSEnableButton $w.buttonRow.ok.button 
    if {$noOk} {
        destroy $w.buttonRow.ok.button
    }
    if {$noCancel} {
        destroy $w.buttonRow.cancel.button
    }


    if {$modal} {
        set oldFocus [focus]
        catch {grab set $w}
        focus $w
        update
        set apsCheckButtonstkWaitVar$apsCheckButtonsID ""
        tkwait variable apsCheckButtonstkWaitVar$apsCheckButtonsID
        focus $oldFocus
        update
        if {[subst \$apsCheckButtonstkWaitVar$apsCheckButtonsID] == "OK"} { return 1 }
        return 0
    }
    return 1
}

